;-TOP


CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
  
  Procedure GetLastError_()
    ProcedureReturn 1
  EndProcedure
  
CompilerEndIf
  

; ***************************************************************************************

CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS

  Procedure UpdateWindow()
  
    Protected x, y, dx, dy, menu, status, toolbar
   
    menu = MenuHeight()
    status = StatusBarHeight(#Main_StatusBar)
    toolbar = ToolBarHeight(#Main_Toolbar)
    x = 0
    y = 0
    dx = WindowWidth(#Main)
    dy = WindowHeight(#Main) - menu - status - toolbar
    ResizeGadget(hSplitter, x, y, dx, dy)
   
  EndProcedure

CompilerElse

  Procedure UpdateWindow()
  
    Protected x, y, dx, dy, menu, status, toolbar
   
    menu = MenuHeight()
    status = StatusBarHeight(#Main_StatusBar)
    toolbar = ToolBarHeight(#Main_Toolbar)
    x = 0
    y = toolbar
    dx = WindowWidth(#Main)
    dy = WindowHeight(#Main) - menu - status - toolbar
    ResizeGadget(hSplitter, x, y, dx, dy)
   
  EndProcedure
  
CompilerEndIf

; ***************************************************************************************

CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS

  Procedure.s FormatMessage(ErrorNumber.l)
  
    Protected *Buffer, len, result.s
    
    len = 0
    If len
      ;
    Else
      ProcedureReturn "Errorcode: " + Hex(ErrorNumber)
    EndIf
    
  EndProcedure

CompilerElse

  Procedure.s FormatMessage(ErrorNumber.l)
  
    Protected *Buffer, len, result.s
    
    len = FormatMessage_(#FORMAT_MESSAGE_ALLOCATE_BUFFER|#FORMAT_MESSAGE_FROM_SYSTEM,0,ErrorNumber,0,@*Buffer,0,0)
    If len
      result = PeekS(*Buffer, len - 2)
      LocalFree_(*Buffer)
      ProcedureReturn result
    Else
      ProcedureReturn "Errorcode: " + Hex(ErrorNumber)
    EndIf
    
  EndProcedure

CompilerEndIf

; ***************************************************************************************

CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS

  Procedure Errorbox(Titel.s, Text.s)
  
    MessageRequester(Titel, Text)
    
  EndProcedure
  
CompilerElse

  Procedure Errorbox(Titel.s, Text.s)
  
    MessageRequester(Titel, Text, #MB_ICONSTOP)
    
  EndProcedure
  
CompilerEndIf
; ***************************************************************************************

Procedure Info(Text.s)
  
  SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvAddInfo, @Text)
  
EndProcedure

Procedure Info2(Text.s)

  Protected count
  
  AddGadgetItem(#Main_Listview_Status, -1, Text)
  count = CountGadgetItems(#Main_Listview_Status) - 1
  
  CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
    SetGadgetState(#Main_Listview_Status, count)
    SetGadgetState(#Main_Listview_Status, -1)
  CompilerElse
    SendMessage_(GadgetID(#Main_Listview_Status), #LB_SETTOPINDEX, count, 0)
  CompilerEndIf
  
EndProcedure

; ***************************************************************************************
Procedure SetStatus(Text.s)

  StatusBarText(#Main_StatusBar, 0, Text)
  
EndProcedure

; ***************************************************************************************

Procedure FindStringEx(String.s, StringToFind.s, Startposition.l = 1)

  Protected uString.s, uStringToFind.s
  
  uString = UCase(String)
  uStringToFind = UCase(StringToFind)
  ProcedureReturn FindString(uString, uStringToFind, Startposition)
  
EndProcedure

; Macro FindStringEx(String, StringToFind, Startposition = 1, Mode = #PB_String_NoCase)
;   FindString(String, StringToFind, Startposition, Mode)
; EndMacro

; ***************************************************************************************

Procedure FindStringLeft(String.s, StringToFind.s, Startposition.l = 0)

  Protected len, len2, index
  
  len = Len(String)
  len2 = Len(StringToFind)
  If Startposition = 0
    Startposition = len
  EndIf
  For index = Startposition To 1 Step - 1
    If Mid(String, index, len2) = StringToFind
      ProcedureReturn index
    EndIf
  Next
  ProcedureReturn 0
  
EndProcedure

; ***************************************************************************************

Procedure.s ReplaceStringEx(String.s, StringToFind.s, StringToReplace.s)

  Protected temp.s, find.s, neu.s, pos, len, ch_left.s, ch_right.s, left_ok, right_ok
  
  temp = UCase(String)
  find = UCase(StringToFind)
  len = Len(find)

  neu = String
  pos = 0
  Repeat
    left_ok = #False
    right_ok = #False
    pos + 1
    pos = FindStringEx(temp, find, pos)
    If pos
      If pos > 1
        ch_left = Mid(temp, pos - 1, 1)
        If (ch_left < "0" Or ch_left > "9")
          If (ch_left < "A" Or ch_left > "Z")
            If ch_left <> "_"
              left_ok = #True
            EndIf
          EndIf
        EndIf
      Else
        left_ok = #True
      EndIf
      ch_right = Mid(temp, pos + len, 1)
      If ch_right = ""
        right_ok = #True
      Else
        If (ch_right < "0" Or ch_right > "9")
          If (ch_right < "A" Or ch_right > "Z")
            If ch_right <> "_"
              right_ok = #True
            EndIf
          EndIf
        EndIf
      EndIf
      If left_ok And right_ok
        neu = Left(neu, pos - 1 ) + StringToReplace + Mid(neu, pos + len)
        temp = UCase(neu)
      EndIf
    EndIf
  Until pos = 0
  
  ProcedureReturn neu
  
EndProcedure

; ***************************************************************************************

Declare LoadProject(project.s)

Procedure InitProgram()
  
  Protected para.s, temp.s, sel.s
  
  path_ini = GetPathPart(ProgramFilename()) + "VG4.INI"
  ; Lade UserGadget
  path_usergadget = GetPathPart(ProgramFilename()) + "UserList.INI"
  If OpenFile(0, path_usergadget)
    If Lof(0) <= 0
      WriteStringN(0, "[USERGADGET]")
    EndIf
    While Eof(0) = 0
      temp = ReadString(0)
      If Left(temp, 1) = "["
        sel = temp
        Continue
      EndIf
      If temp = ""
        sel = ""
        Continue
      EndIf
      Select sel
        Case "[USERGADGET]"
          AddElement(ListUserGadget())
          ListUserGadget() = Trim(temp)
          
      EndSelect 
    Wend
    CloseFile(0)
  Else
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      Errorbox("UserGadgetList", FormatMessage(GetLastError_()))
    CompilerElse
      Errorbox("UserGadgetList", "Error open file usergadgetlist")
    CompilerEndIf
  EndIf
  
  ; Lade gltige Funktion
  
  Restore ValidFunction
  Repeat
    Read.s temp
    If temp = ""
      Break
    EndIf
    temp = UCase(temp)
    AddMapElement(MapValidFunction(),temp)
  ForEver
  
  ForEach ListUserGadget()
    temp = ListUserGadget()
    temp = UCase(temp)
    AddMapElement(MapValidFunction(),temp)
  Next
  
  ; Lade gltige Gadgets
  
  Restore ValidGadget
  Repeat
    Read.s temp
    If temp = ""
      Break
    EndIf
    temp = UCase(temp)
    AddMapElement(MapValidGadget(),temp)
  ForEver
  
  ForEach ListUserGadget()
    temp = ListUserGadget()
    temp = UCase(temp)
    AddMapElement(MapValidGadget(),temp)
  Next
  
  ; Lade bergebenes Projekt
  para = ProgramParameter()
  If FileSize(para) > 0
     path_project = para
     LoadProject(path_project)
     SetStatus(path_project)
     ProcedureReturn #True
  EndIf
  
  ; Lade letztes Projekt
  path_project = ReadINI("Path", "Project", path_ini)  
  If FileSize(path_project) > 0
     LoadProject(path_project)
     SetStatus(path_project)
     ProcedureReturn #True
  EndIf
  
  ; Lade Grundeinstellungen
  path_project = "project.pbm"
  path_last = ReadINI("Path", "Last", path_ini)
  With Switch
    \Parend = Val(ReadINI("Default", "Parend", path_ini, "1"))
    \PB_Ignore = Val(ReadINI("Default", "PB_Ignore", path_ini, "1"))
    \Multilang = Val(ReadINI("Default", "Multilang", path_ini, "0"))
    \Image_Include = Val(ReadINI("Default", "Image_Include", path_ini, "0"))
    \Image_Null = Val(ReadINI("Default", "Image_Null", path_ini, "0"))
    \Utf8 = Val(ReadINI("Default", "Utf8", path_ini, "1"))
    \MacMenuEvents = Val(ReadINI("Default", "MacMenuEvents", path_ini, "1"))
  EndWith
  
  ; Status
  IsLoad = #False
  IsSave = #True
  SetStatus(path_project)
    
EndProcedure

; ***************************************************************************************

Procedure ExitProgram()

  ; Speicher Grundeinstellungen
  WriteINI("Path", "Last", path_last, path_ini)
  WriteINI("Path", "Project", path_project, path_ini)
  With Switch
    WriteINI("Default", "Parend", Str(\Parend), path_ini)
    WriteINI("Default", "PB_Ignore", Str(\PB_Ignore), path_ini)
    WriteINI("Default", "Multilang", Str(\Multilang), path_ini)
    WriteINI("Default", "Image_Include", Str(\Image_Include), path_ini)
    WriteINI("Default", "Image_Null", Str(\Image_Null), path_ini)
    WriteINI("Default", "Utf8", Str(\Utf8), path_ini)
    WriteINI("Default", "MacMenuEvents", Str(\MacMenuEvents), path_ini)
  EndWith
 
EndProcedure

; ***************************************************************************************

Procedure LoadProject(project.s)
  
  Protected temp.s, key.s, value.l, svalue.s, sel.s
  
  ; Liste Common lschen
  ClearGadgetItems(#Main_Listview_Common) 
  ; Liste Status lschen
  ClearGadgetItems(#Main_Listview_Status) 
  ; Liste Alt lschen
  ClearList(ListOld.s())
  ClearList(ListOldWindow.s())
  ClearList(ListOldMenu.s())
  ClearList(ListOldMenuItem.s())
  ClearList(ListOldStatusBar.s())
  ClearList(ListOldToolBar.s())
  ClearList(ListOldGadget.s())
  
  ClearList(ListOld())
  ClearList(ListFind())

  ClearList(ListCheckAlt())
  ClearList(ListCheckNeu())
  ClearList(ListCheck())
  
  ; Status setzen
  IsLoad = #False
  IsSave = #True

  ; Liste laden
  If ReadFile(0, project)
    ClearList(ListProject())
    While Eof(0) = 0
      temp = ReadString(0)
      AddElement(ListProject())
      ListProject() = temp
    Wend
    ; Datei schliessen
    CloseFile(0)
    ForEach ListProject()
      temp = ListProject()
      If Left(temp, 1) = "["
        sel = temp
        Continue
      EndIf
      If temp = ""
        sel = ""
        Continue
      EndIf
      Select sel
        Case "[FILES]"
          AddGadgetItem(#Main_Listview_Common, -1, temp)  
          Continue
        
        Case "[SWITCH]"
          temp  = RemoveString(temp, ";")
          key   = StringField(temp, 1, "=")
          svalue = StringField(temp, 2, "=")
          value = Val(svalue)
          Select key
            Case "Parend"           : Switch\Parend = value
            Case "PB_Ignore"        : Switch\PB_Ignore = value
            Case "Multilang"        : Switch\Multilang = value
            Case "Image_Include"    : Switch\Image_Include = value
            Case "Image_Null"       : Switch\Image_Null = value
            Case "Utf8"             : Switch\Utf8 = value
            Case "MacMenuEvents"    : Switch\MacMenuEvents = value
          EndSelect
          Continue
        
        Case "[WINDOW]"
          AddElement(ListOldWindow())
          ListOldWindow() = temp
          Continue
        Case "[MENU]"
          AddElement(ListOldMenu())
          ListOldMenu() = temp
          Continue
        Case "[MENUITEM]"
          AddElement(ListOldMenuItem())
          ListOldMenuItem() = temp
          Continue
        Case "[STATUSBAR]"
          AddElement(ListOldStatusBar())
          ListOldStatusBar() = temp
          Continue
        Case "[TOOLBAR]"
          AddElement(ListOldToolBar())
          ListOldToolBar() = temp
          Continue
        Case "[GADGET]"
          AddElement(ListOldGadget())
          ListOldGadget() = temp
          Continue
        
      EndSelect
    Next
    
    IsLoad = #True
    IsSave = #True
    ProcedureReturn #True
  Else
    ; -------------------------------------------
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux
      Errorbox("UserGadgetList", "Error open file project")
    CompilerElse
      Errorbox("UserGadgetList", FormatMessage(GetLastError_()))
    CompilerEndIf
    ; -------------------------------------------
  EndIf
  ProcedureReturn #False
  
EndProcedure

; ***************************************************************************************

Procedure SaveProject(project.s, IsNeu.l = #False)
  
  Protected count, index, temp.s
  
  count = CountGadgetItems(#Main_Listview_Common)
  If count
    If CreateFile(0, project)
      count - 1
      ; Dateiliste schreiben
      WriteStringN(0, "[FILES]")
      For index = 0 To count
        temp = GetGadgetItemText(#Main_Listview_Common, index, 0)
        WriteStringN(0, temp)
      Next index
      WriteStringN(0, "")
      ; Einstellungen schreiben
      WriteStringN(0, "[SWITCH]")
      With Switch
        WriteStringN(0, "Parend="          + Str(\Parend))
        WriteStringN(0, "PB_Ignore="       + Str(\PB_Ignore))
        WriteStringN(0, "Multilang="       + Str(\Multilang))
        WriteStringN(0, "Image_Include="   + Str(\Image_Include))
        WriteStringN(0, "Image_Null="      + Str(\Image_Null))
        WriteStringN(0, "Utf8="            + Str(\Utf8))
        WriteStringN(0, "MacMenuEvents="   + Str(\MacMenuEvents))
      EndWith
      WriteStringN(0, "")
      If IsNeu
        ; Konstanden Neu
        WriteStringN(0, "[WINDOW]")
        ForEach ListFindWindow()
          WriteStringN(0, ListFindWindow())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[MENU]")
        ForEach ListFindMenu()
          WriteStringN(0, ListFindMenu())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[MENUITEM]")
        ForEach ListFindMenuItem()
          WriteStringN(0, ListFindMenuItem())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[STATUSBAR]")
        ForEach ListFindStatusBar()
          WriteStringN(0, ListFindStatusBar())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[TOOLBAR]")
        ForEach ListFindToolBar()
          WriteStringN(0, ListFindToolBar())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[GADGET]")
        ForEach ListFindGadget()
          WriteStringN(0, ListFindGadget()\Const)
        Next
        WriteStringN(0, "")
      Else
         ; Konstanden Alt
        WriteStringN(0, "[WINDOW]")
        ForEach ListOldWindow()
          WriteStringN(0, ListOldWindow())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[MENU]")
        ForEach ListOldMenu()
          WriteStringN(0, ListOldMenu())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[MENUITEM]")
        ForEach ListOldMenuItem()
          WriteStringN(0, ListOldMenuItem())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[STATUSBAR]")
        ForEach ListOldStatusBar()
          WriteStringN(0, ListOldStatusBar())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[TOOLBAR]")
        ForEach ListOldToolBar()
          WriteStringN(0, ListOldToolBar())
        Next
        WriteStringN(0, "")
        WriteStringN(0, "[GADGET]")
        ForEach ListOldGadget()
          WriteStringN(0, ListOldGadget())
        Next
        WriteStringN(0, "")
      EndIf
      IsSave = #True
      IsLoad = #True
      ; Datei schliessen
      CloseFile(0)
      ProcedureReturn #True
    Else
      ; -------------------------------------------
      CompilerIf #PB_Compiler_OS = #PB_OS_Linux
        Errorbox("UserGadgetList", "Error save file project")
      CompilerElse
        Errorbox("UserGadgetList", FormatMessage(GetLastError_()))
      CompilerEndIf
      ; -------------------------------------------
    EndIf
  EndIf
  ProcedureReturn #False
  
EndProcedure

; ***************************************************************************************

Procedure Common_Add()
  
  Protected temp.s
  
  temp = OpenFileRequester("Commonfile", path_last, "Common|*.pb*|Alle Dateien|*.*", 0, #PB_Requester_MultiSelection)
  If temp
    path_last = GetPathPart(temp)
    IsSave = #False
  EndIf
  While temp
    AddGadgetItem(#Main_Listview_Common, -1, temp)
    temp = NextSelectedFileName()
  Wend
  
EndProcedure

; ***************************************************************************************

Procedure Common_Delete()
  
  Protected index
  
  index = GetGadgetState(#Main_listview_Common)
  If index >= 0
    RemoveGadgetItem(#Main_Listview_Common, index)
    IsSave = #False
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure Common_First()

  Protected index, temp.s
  
  index = GetGadgetState(#Main_listview_Common)
  If index >= 0
    temp = GetGadgetItemText(#Main_Listview_Common, index, 0)
    RemoveGadgetItem(#Main_Listview_Common, index)
    AddGadgetItem(#Main_Listview_Common, 0, temp)
    IsSave = #False
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure Project_Save_As()
  
  Protected temp.s, result, path.s
  
  path = path_last + GetFilePart(path_project)
  temp = SaveFileRequester("Save project", path, "Project (*.pbm)|*.pbm", 0)
  
  If temp
    If GetExtensionPart(temp) = ""
      temp + ".pbm"
    EndIf
    If FileSize(temp) >= 0
      ; -------------------------------------------
      CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
        result = MessageRequester("Frage", "Datei berschreiben?", #PB_MessageRequester_YesNo)
      CompilerElse
        result = MessageRequester("Frage", "Datei berschreiben?", #MB_ICONQUESTION | #PB_MessageRequester_YesNo)
      CompilerEndIf
      ; -------------------------------------------
      If result = #PB_MessageRequester_No
        ProcedureReturn #False
      EndIf
    EndIf
    
    If SaveProject(temp)
      path_last = GetPathPart(temp)
      path_project = temp
      SetStatus(path_project)
      ProcedureReturn #True
    EndIf
  EndIf
  
  ProcedureReturn #False
  
EndProcedure

; ***************************************************************************************

Procedure Project_Load()
  
  Protected temp.s, result
  
  If IsSave = #False
    ; -------------------------------------------
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #PB_MessageRequester_YesNo)
    CompilerElse
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #MB_ICONQUESTION | #PB_MessageRequester_YesNo)
    CompilerEndIf
    ; -------------------------------------------
    If result = #PB_MessageRequester_Yes
      If IsLoad
        SaveProject(path_project)
      Else
        If Project_Save_As() = #False
          ProcedureReturn #False
        EndIf
      EndIf
    EndIf
  EndIf
  
  temp = OpenFileRequester("Load project", path_last, "Project (*.pbm)|*.pbm", 0)
  If temp
    If LoadProject(temp)
      path_last = GetPathPart(temp)
      path_project = temp
      SetStatus(path_project)
    EndIf
  EndIf
    
EndProcedure

; ***************************************************************************************

Procedure Project_New()
  
  Protected result
  
  If IsSave = #False
    ; -------------------------------------------
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #PB_MessageRequester_YesNo)
    CompilerElse
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #MB_ICONQUESTION | #PB_MessageRequester_YesNo)
    CompilerEndIf
    ; -------------------------------------------
    If result = #PB_MessageRequester_Yes
      If IsLoad
        SaveProject(path_project)
      Else
        If Project_Save_As() = #False
          ProcedureReturn #False
        EndIf
      EndIf
    EndIf
  EndIf
  
  ; Liste Common lschen
  ClearGadgetItems(#Main_Listview_Common) 
  ; Liste Status lschen
  ClearGadgetItems(#Main_Listview_Status) 
  ; Liste Alt lschen
  ClearList(ListProject.s())
  
  ClearList(ListOld.s())
  ClearList(ListOldWindow.s())
  ClearList(ListOldMenu.s())
  ClearList(ListOldMenuItem.s())
  ClearList(ListOldStatusBar.s())
  ClearList(ListOldToolBar.s())
  ClearList(ListOldGadget.s())
  
  ClearList(ListOld())
  ClearList(ListFind())

  ClearList(ListCheckAlt())
  ClearList(ListCheckNeu())
  ClearList(ListCheck())
  
  ; Init Daten
  IsLoad = #False
  IsSave = #True
  path_project = "Unbekannt.pbm"
  SetStatus(path_project)
    
EndProcedure

; ***************************************************************************************

Procedure Project_Exit()

  Protected result
  
  If IsSave = #False
    ; ------------------------------------------
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_MacOS
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #PB_MessageRequester_YesNo)
    CompilerElse
      result = MessageRequester("Frage", "Aktuelles Projekt speichern?", #MB_ICONQUESTION | #PB_MessageRequester_YesNo)
    CompilerEndIf
    ; ------------------------------------------
    If result = #PB_MessageRequester_Yes
      If IsLoad
        SaveProject(Path_project)
      Else
        If Project_Save_As() = #False
          ProcedureReturn #False
        EndIf
      EndIf
    EndIf
  EndIf
  
  ExitApplication = 1

EndProcedure
   
; ***************************************************************************************

Procedure InitStartWindow()

  Open_Start()
  DisableWindow(#Main, #True)
  
  With Switch
    SetGadgetState(#Start_CheckBox_Parend, \Parend)
    SetGadgetState(#Start_CheckBox_PB_Ignore, \PB_Ignore)
    SetGadgetState(#Start_CheckBox_Mehrsprachig, \Multilang)
    SetGadgetState(#Start_CheckBox_ImageID_Include, \Image_Include)
    SetGadgetState(#Start_CheckBox_ImageID_Null, \Image_Null)
    SetGadgetState(#Start_CheckBox_Utf8, \Utf8)
    SetGadgetState(#Start_CheckBox_MacMenuEvents, \MacMenuEvents)
  EndWith
    
EndProcedure

; ***************************************************************************************

Procedure ExitStartWindow()
    
  DisableWindow(#Main, #False)
  CloseWindow(#Start)
  
EndProcedure

; ***************************************************************************************

Procedure InitCheckWindow(type)

  Protected temp.s
  
  Open_Check()
  DisableWindow(#Main, #True)
  temp = "Search and Replace - "
  Select type
    Case 1 : temp + "Window"
    Case 2 : temp + "MenuBar"
    Case 3 : temp + "MenuItem"
    Case 4 : temp + "StatusBar"
    Case 5 : temp + "ToolBar"
    Case 6 : temp + "Gadget"
      
  EndSelect
  
  SetWindowTitle(#Check, temp)
  
  ForEach ListCheckAlt()
    AddGadgetItem(#Check_Listview_alt, -1, ListCheckAlt())
  Next
  ForEach ListCheckNeu()
    AddGadgetItem(#Check_Listview_neu, -1, ListCheckNeu())
  Next
  

EndProcedure

; ***************************************************************************************

Procedure ExitCheckWindow()
    
  DisableWindow(#Main, #False)
  CloseWindow(#Check)
  
EndProcedure

; ***************************************************************************************

Procedure InitUserGadgetWindow()

  Open_UserGadget()
  DisableWindow(#Main, #True)
  ; Listbox fllen
  ForEach ListUserGadget()
    AddGadgetItem(#UserGadget_Listview_Gadget, -1, ListUserGadget())
  Next
  
EndProcedure

; ***************************************************************************************

Procedure ExitUserGadgetWindow()
  
  DisableWindow(#Main, #False)
  CloseWindow(#UserGadget)
  
EndProcedure

; ***************************************************************************************

Procedure UserGadgetAdd()

  Protected pos, temp.s
  
  temp = InputRequester("Add Gadget", "", temp)
  If temp
    AddGadgetItem(#UserGadget_Listview_Gadget, -1, temp, 0)
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure UserGadgetEdit()

  Protected pos, temp.s
  
  pos = GetGadgetState(#UserGadget_Listview_Gadget)
  If pos >=0
    temp = GetGadgetItemText(#UserGadget_Listview_Gadget, pos, 0)
    temp = InputRequester("Edit Gadget", "", temp)
    If temp
      SetGadgetItemText(#UserGadget_Listview_Gadget, pos, temp, 0)
    EndIf
  EndIf

EndProcedure

; ***************************************************************************************

Procedure UserGadgetDelete()

  Protected pos, temp.s
  
  pos = GetGadgetState(#UserGadget_Listview_Gadget)
  If pos >=0
    RemoveGadgetItem(#UserGadget_Listview_Gadget, pos)
  EndIf

EndProcedure

; ***************************************************************************************

Procedure UserGadgetOk()

  Protected count, index
  
  ClearList(ListUserGadget())
  count = CountGadgetItems(#UserGadget_Listview_Gadget)
  For index = 0 To count - 1
    AddElement(ListUserGadget())
    ListUserGadget() = GetGadgetItemText(#UserGadget_Listview_Gadget, index, 0)
  Next
  If CreateFile(0, path_usergadget)
    WriteStringN(0, "[USERGADGET]")
    ForEach ListUserGadget()
      WriteStringN(0, ListUserGadget())
    Next
    CloseFile(0)
  Else
    ; ---------------------------------------
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux
      Errorbox("Save UserGadget", "Error save file usergadet")
    CompilerElse
      Errorbox("Save UserGadget", FormatMessage(GetLastError_()))
    CompilerEndIf
    ; ---------------------------------------
  EndIf
  
  ExitUserGadgetWindow()
  
EndProcedure

; ***************************************************************************************
; IDE Options = PureBasic 5.42 Beta 4 LTS (MacOS X - x64)
; CursorPosition = 788
; FirstLine = 784
; Folding = --------
; CompileSourceDirectory