;-TOP
; Kommentar     : Include INI-Dateien
; Author        : mk-soft
; Second Author : 
; Datei         : INI-File.pb
; Version       : 1.01
; Erstellt      : 
; Gendert      : 02.10.2006
; 
; Compilermode  :
;
; ***************************************************************************************

Procedure GetSectionsNames(path.s, List MyList.s())

  Protected temp.s
  
  If OpenPreferences(path) = 0
    ProcedureReturn 0
  EndIf
  
  If ExaminePreferenceGroups()
    While NextPreferenceGroup()
      temp = PreferenceGroupName()
      If temp <> ""
        AddElement(Mylist())
        Mylist() = temp
      EndIf
    Wend
  EndIf
  
  ClosePreferences()
  
EndProcedure

; ***************************************************************************************

Procedure GetSection(section.s, path.s, List MyList.s())

  Protected temp.s
  
  If OpenPreferences(path) = 0
    ProcedureReturn 0
  EndIf
  
  If PreferenceGroup(section) = 0
    ClosePreferences()
    ProcedureReturn 0
  EndIf
  
  If ExaminePreferenceKeys()
    While NextPreferenceKey()
      temp = PreferenceKeyName()
      If temp <> ""
        AddElement(MyList())
        Mylist() = temp
      EndIf
    Wend
  EndIf
  
  ClosePreferences()
  
EndProcedure

; ***************************************************************************************

Procedure.s ReadINI(lpAppName.s, lpKeyName.s, lpFileName.s, lpDefault.s = "")

  Protected Result.s
 
  If OpenPreferences(lpFileName) = 0
    ProcedureReturn lpDefault
  EndIf
  
  If PreferenceGroup(lpAppName) = 0
    ClosePreferences()
    ProcedureReturn lpDefault
  EndIf
  
  result = ReadPreferenceString(lpKeyName, lpDefault)
  ClosePreferences()
  
  ProcedureReturn Result
 
EndProcedure

; ***************************************************************************************

Procedure WriteINI(lpszSection.s, lpszKey.s, lpszString.s, lpszFile.s)

  Protected result
  
  If OpenPreferences(lpszFile) = 0
    If CreatePreferences(lpszFile) = 0
      ProcedureReturn 0
    EndIf
  EndIf
  
  PreferenceGroup(lpszSection)
  
  WritePreferenceString(lpszKey, lpszString)
  ClosePreferences()
  
  ProcedureReturn Result
 
EndProcedure

; ***************************************************************************************

; IDE Options = PureBasic 5.10 Beta 1 (Windows - x64)
; CursorPosition = 55
; FirstLine = 26
; Folding = -