;- TOP

; Thread-Message-System

Global __MsgMutex__

Prototype ProtoMsgCallback(msg, *pdata, text.s)
Global __MsgCallback__.ProtoMsgCallback = 0

__MsgMutex__ = CreateMutex()

Structure __udtMessages__
  msg.i
  *pdata
  text.s
  post.i
  ready.i
  result.i
EndStructure

Global NewList __Messages__.__udtMessages__()

; ***************************************************************************************

Procedure SendMsg(msg, *pdata = 0, text.s = "")
  
  Protected *message.__udtMessages__, result
    
  LockMutex(__MsgMutex__)
  AddElement(__Messages__())
  *message = __Messages__()
  With *message
    \msg = msg
    \pdata = *pdata
    \text = text
    \ready = #False
  EndWith
  UnlockMutex(__MsgMutex__)
  While *message\ready = #False
    Delay(10)
  Wend
  LockMutex(__MsgMutex__)
  result = *message\result
  ChangeCurrentElement(__Messages__(), *message)
  DeleteElement(__Messages__())
  UnlockMutex(__MsgMutex__)
  ProcedureReturn result
  
EndProcedure

; ***************************************************************************************

Procedure PostMsg(msg, *pdata = 0, text.s = "")
  
  Protected *message.__udtMessages__
    
  LockMutex(__MsgMutex__)
  AddElement(__Messages__())
  *message = __Messages__()
  With *message
    \msg = msg
    \pdata = *pdata
    \text = text
    \post = #True
    \ready = #False
  EndWith
  UnlockMutex(__MsgMutex__)
  
EndProcedure

; ***************************************************************************************

Procedure SetMsgCallback(*MsgCallback)
  
  Protected *old
  
  *old = __MsgCallback__
  __MsgCallback__ = *MsgCallback
  ProcedureReturn *old
  
EndProcedure

; ***************************************************************************************

Procedure DispatchMsg()
  
  LockMutex(__MsgMutex__)
  ForEach __Messages__()
    With __Messages__()
      If \ready = #False
        If __MsgCallback__
          \result = __MsgCallback__(\msg, \pdata, \text)
        Else
          \result = 0
        EndIf
        \ready = #True
        If \post
          DeleteElement(__Messages__())
        EndIf
      EndIf
    EndWith
  Next
  UnlockMutex(__MsgMutex__)
  
EndProcedure

; IDE Options = PureBasic 4.50 (Linux - x86)
; CursorPosition = 54
; Folding = -
; EnableXP