;- TOP

; Thread-Message-System

Global __MsgMutex__

Prototype ProtoMsgCallback(hWnd, uMsg, wParam, lParam)
Global __MsgCallback__.ProtoMsgCallback = 0

__MsgMutex__ = CreateMutex()

Structure __udtMessages__
  hWnd.i
  uMsg.i
  wParam.i
  lParam.i
  ready.i
  result.i
EndStructure

Global NewList __Messages__.__udtMessages__()

; ***************************************************************************************

Procedure SendMessage(hWnd, uMsg, wParam, lParam)
  
  Protected *message.__udtMessages__, result
    
  LockMutex(__MsgMutex__)
  LastElement(__Messages__())
  AddElement(__Messages__())
  *message = __Messages__()
  With *message
    \hWnd = hWnd
    \uMsg = uMsg
    \wParam = wParam
    \lParam = lParam
    \ready = #False
  EndWith
  UnlockMutex(__MsgMutex__)
  While *message\ready = #False
    Delay(0)
  Wend
  LockMutex(__MsgMutex__)
  result = *message\result
  ChangeCurrentElement(__Messages__(), *message)
  DeleteElement(__Messages__())
  UnlockMutex(__MsgMutex__)
  ProcedureReturn result
  
EndProcedure

; ***************************************************************************************

; ***************************************************************************************

Procedure SetMsgCallback(*MsgCallback)
  
  Protected *old
  
  *old = __MsgCallback__
  __MsgCallback__ = *MsgCallback
  ProcedureReturn *old
  
EndProcedure

; ***************************************************************************************

Procedure DispatchMsg()
  
  LockMutex(__MsgMutex__)
  ForEach __Messages__()
    With __Messages__()
      If \ready = #False
        If __MsgCallback__
          \result = __MsgCallback__(\hWnd, \uMsg, \wParam, \lParam)
        Else
          \result = 0
        EndIf
      EndIf
      \ready = #True
    EndWith
  Next
  UnlockMutex(__MsgMutex__)
  
EndProcedure

; IDE Options = PureBasic 5.10 Beta 1 (Windows - x86)
; CursorPosition = 41
; FirstLine = 30
; Folding = -
; EnableXP
; CompileSourceDirectory