﻿; ***************************************************************************************

;-TOP
; Comment : SendEvent
; Author  : mk-soft
; Version : v1.02

;- Structure
Structure udtSendEvent
  Signal.i
  Result.i
  *pData
EndStructure

; ---------------------------------------------------------------------------------------

Procedure SendEvent(Type, Window, Object, EventType, pData = 0)
  
  Protected Event.udtSendEvent, result
  
  With Event
    \Signal = CreateSemaphore()
    \pData = pData
    PostEvent(Type, Window, Object, EventType, @Event)
    
    WaitSemaphore(\Signal)
    result = \Result
    FreeSemaphore(\Signal)
  EndWith
  
  ProcedureReturn result
  
EndProcedure

; ---------------------------------------------------------------------------------------

Procedure SendEventData(*Event.udtSendEvent)
  
   ProcedureReturn *Event\pData
 
EndProcedure

; ---------------------------------------------------------------------------------------

Procedure DispatchEvent(*Event.udtSendEvent, result)
  
  *Event\Result = result
  SignalSemaphore(*Event\Signal)
  
EndProcedure

; ***************************************************************************************

; IDE Options = PureBasic 5.10 (Windows - x86)
; CursorPosition = 11
; Folding = -
; EnableThread
; EnableXP
; CompileSourceDirectory