; ***************************************************************************************

Procedure AddListTrenn(List List.s())

  AddElement(List())
  List() = ""
  AddElement(List())
  List() = #Trennzeile
  AddElement(List())
  List() = ""

EndProcedure

; ***************************************************************************************

Procedure DoInitList()
  
  ClearList(ListFiles())
  ClearList(ListIncludeFiles())
  ClearList(ListCommon())
  ClearList(ListEnumeration())
  ClearList(ListImage())
  ClearList(ListFont())
  ;ClearList(ListUserGadget())

  ClearList(ListFindWindow())
  ClearList(ListFindMenu())
  ClearList(ListFindMenuItem())
  ClearList(ListFindStatusBar())
  ClearList(ListFindToolBar())
  ClearList(ListFindGadget())
  ClearList(ListFindImage())
  ClearList(ListFindFont())
  
  ClearList(ListFileCommon())
  ClearList(ListFileMain())
  ClearList(ListFileEventMain())
  ClearList(ListFileEventWindow())
  ClearList(ListFileEventMenu())
  ClearList(ListFileEventGadget())
  ClearList(ListFileLang())
  ClearList(ListFileImage())
  ClearList(ListFileInclude())
  
  ClearMap(MapLanguage())
  
EndProcedure

; ***************************************************************************************

Procedure DoLoadFileList()

  Protected count, index, sTemp.s
  
  count = CountGadgetItems(#Main_Listview_Common)
  If count
    count - 1
    For index = 0 To count
      sTemp = GetGadgetItemText(#Main_Listview_Common, index, 0)
      AddElement(ListFiles())
      ListFiles() = sTemp
    Next
  EndIf

EndProcedure

; ***************************************************************************************

Procedure DoLoadIncludeFileList(File.s)

  Protected FF, Ft, Path.s, IFile.s, Path2.s, Line.s, Pos, PosB, PosE, sTemp.s
  
  If File <> ""
    Path2 = GetPathPart(path_project)
    File = Path2 + File
    
    FF = ReadFile(#PB_Any, File)
    If FF
      If ReadStringFormat(FF) <> #PB_Ascii : Ft = #PB_UTF8 : EndIf
  
      While Not Eof(FF)
        IFile = ""
    
        Line = ReadString(FF, Ft)
  
        Pos = FindString(Line, "IncludePath", 1)
        If FindStringLeft(Line, ";", Pos) Or FindStringLeft(Line, #DQUOTE$, Pos)
          Pos = 0
        EndIf
        If Pos
          PosB = FindString(Line, #DQUOTE$, Pos + 12) + 1
          PosE = FindString(Line, #DQUOTE$, PosB)
          If PosB And PosE
            Path = Mid(Line, PosB, PosE - PosB)
          EndIf
        EndIf
  
        Pos = FindString(Line, "IncludeFile", 1)
        If FindStringLeft(Line, ";", Pos) Or FindStringLeft(Line, #DQUOTE$, Pos)
          Pos = 0
        EndIf
        If Pos
          PosB = FindString(Line, #DQUOTE$, Pos + 12) + 1
          PosE = FindString(Line, #DQUOTE$, PosB)
          If PosB And PosE
            IFile = Mid(Line, PosB, PosE - PosB)
          EndIf
        EndIf
  
        Pos = FindString(Line, "XIncludeFile", 1)
        If FindStringLeft(Line, ";", Pos) Or FindStringLeft(Line, #DQUOTE$, Pos)
          Pos = 0
        EndIf
        If Pos
          PosB = FindString(Line, #DQUOTE$, Pos + 13) + 1
          PosE = FindString(Line, #DQUOTE$, PosB)
          If PosB And PosE
            IFile = Mid(Line, PosB, PosE - PosB)
          EndIf
        EndIf
        
        sTemp = UCase(IFile)
        If sTemp = "COMMONFILE.PB"
          Continue
        EndIf
        If sTemp = "EVENTMAIN.PB"
          Continue
        EndIf
        If sTemp = "EVENTMENU.PB"
          Continue
        EndIf
        If sTemp = "EVENTGADGET.PB"
          Continue
        EndIf
        If sTemp = "EVENTWINDOW.PB"
          Continue
        EndIf
        
        If IFile <> ""
          sTemp = GetPathPart(IFile)
          
          If sTemp = ""
            sTemp = Path2 + IFile
            
            CompilerIf #PB_Compiler_OS = #PB_OS_Windows
              ElseIf Left(sTemp,1) = "\"
            CompilerElse
              ElseIf Left(sTemp,1) = "/"
            CompilerEndIf
            
            sTemp = Left(Path2, Len(path2) - 1) + IFile
          Else
            sTemp = IFile
          EndIf
          AddElement(ListIncludeFiles())
          ListIncludeFiles() = sTemp
          
        EndIf
      Wend
      CloseFile(FF)
    EndIf
  EndIf

EndProcedure

; ***************************************************************************************

Procedure DoCheckBOM()
  
  Protected path.s, file.s, ft
  
  ; Init
  path = GetPathPart(path_project)
  
  ; Main
  file = path + "Main.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    CloseFile(0)
  Else
    ft = 0
  EndIf
  ProcedureReturn ft
  
EndProcedure

; ***************************************************************************************

Procedure DoLoadCommon()

  Protected sTemp.s, pos, start, ende, len, start2, ende2, const.s, file.s, ft, ext.s, fix_image_id.s
  Protected sTemp2.s
  
  ForEach ListFiles()
    ext = GetExtensionPart(ListFiles())
    ext = UCase(ext)
    fix_image_id = ""
    ; Datei ffnen
    If ReadFile(0, ListFiles()) = 0
      sTemp = "Error " + ListFiles() + ": "
      ; ---------------------------------------
      CompilerIf #PB_Compiler_OS = #PB_OS_Linux
        sTemp + "Open file error"  
      CompilerElse
        sTemp + FormatMessage(GetLastError_())
      CompilerEndIf
      ; ---------------------------------------
      Continue
    EndIf
    
    ; Begin Fixed FormDesigner suche Prefix
    ft = ReadStringFormat(0)
    If ext = "PBF"
      While Not Eof(0)
        sTemp = ReadString(0, ft)
        pos = FindStringEx(sTemp, "OPENWINDOW(")
        If pos
          start = FindString(sTemp, "#") + 1
          ende = FindString(sTemp, ",", start)
          len = ende - start
          const = Mid(sTemp, start, len)
          const = Trim(const)
          fix_image_id = const
        EndIf
      Wend
      FileSeek(0, 0)
      ft = ReadStringFormat(0)
    EndIf
    ; End Fixed
    
    ; Datei einlesen
    start = 0
    ende = 0
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      ; Suche Start Procedure
      If FindString(UCase(sTemp), "PROCEDURE ", 1)
        start = #True
      EndIf
      ; Zeile einlesen
      If start
        
        ; Begin Fixed FormDesigner
        If ext = "PBF" 
          sTemp = ReplaceString(sTemp, "Procedure Open", "Procedure Open_", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "Procedure ResizeGadgets", "Procedure Resize_", #PB_String_NoCase)
          
          sTemp = ReplaceString(sTemp, "CreateMenu(0", "CreateMenu(#Menu", #PB_String_NoCase)
          
          sTemp = ReplaceString(sTemp, "CreateToolBar(0", "CreateToolbar(#ToolBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "ToolBarToolTip(0", "ToolBarToolTip(#ToolBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "ToolBarHeight(0", "ToolBarHeight(#ToolBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "GetToolBarButtonState(0", "GetToolBarButtonState(#ToolBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "SetToolBarButtonState(0", "SetToolBarButtonState(#ToolBar", #PB_String_NoCase)
              
          sTemp = ReplaceString(sTemp, "CreateStatusBar(0", "CreateStatusBar(#StatusBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "StatusBarText(0", "StatusBarText(#StatusBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "StatusBarImage(0", "StatusBarImage(#StatusBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "StatusBarProgress(0", "StatusBarProgress(#StatusBar", #PB_String_NoCase)
          sTemp = ReplaceString(sTemp, "StatusBarHeight(0", "StatusBarHeight(#StatusBar", #PB_String_NoCase)
          
          ; Korrektur LoadImage(#PB_Any, ...)
          pos = FindString(sTemp, "LoadImage(#PB_Any", 1, #PB_String_NoCase)
          If pos
            sTemp2 = "#" + Trim(StringField(sTemp, 1, " "))
            sTemp = Mid(sTemp, pos)
            sTemp = ReplaceString(sTemp, "#PB_Any", sTemp2, #PB_String_NoCase)
          EndIf
          
          pos = FindString(sTemp, "ImageID(", 1, #PB_String_NoCase)
          If pos
            pos + 8
            If Mid(sTemp, pos, 1) <> "#"
              sTemp = ReplaceString(sTemp, "ImageID(", "ImageID(#", #PB_String_NoCase)
            EndIf
          EndIf
          
        EndIf
        ; End Fixed FormDesigner
        
        AddElement(ListCommon())
        ListCommon() = sTemp
      EndIf
      ; Suche Ende Procedure
      If FindString(UCase(sTemp), "ENDPROCEDURE", 1)
        ende = #True
      EndIf
      ; Trennzeilen anfgen
      If ende
        start = #False
        ende = #False
        AddListTrenn(ListCommon())
      EndIf
      
      If Not start
        
        ; Korrektur LoadImage(#PB_Any, ...)
        pos = FindString(sTemp, "LoadImage(#PB_Any", 1, #PB_String_NoCase)
        If pos
          sTemp2 = "#" + Trim(StringField(sTemp, 1, " "))
          sTemp = Mid(sTemp, pos)
          sTemp = ReplaceString(sTemp, "#PB_Any", sTemp2, #PB_String_NoCase)
        EndIf
        
        pos = FindString(sTemp, "ImageID(", 1, #PB_String_NoCase)
        If pos
          pos + 8
          If Mid(sTemp, pos, 1) <> "#"
            sTemp = ReplaceString(sTemp, "ImageID(", "ImageID(#", #PB_String_NoCase)
          EndIf
        EndIf
        
        ; LoadImage suchen Ausserhalb von Procedure
        pos = FindString(UCase(sTemp), "LOADIMAGE(", 1)
        If pos
          If FindStringLeft(sTemp, ";", pos) = 0
            start2 = FindString(sTemp, "(") + 1
            ende2 = FindString(sTemp, ",", start2)
            const = Mid(sTemp, start2, ende2 - start2)
            AddElement(ListFindImage())
            ListFindImage()\Const = const
            start2 = FindString(sTemp, Chr(34)) + 1
            ende2 = FindString(sTemp, Chr(34), start2)
            file = Mid(sTemp, start2, ende2 - start2)
            ListFindImage()\File = file
          EndIf
        EndIf
        
        ; LoadFont suchen Ausserhalb von Procedure
        pos = FindString(UCase(sTemp), "LOADFONT(", 1)
        If pos
          If FindStringLeft(sTemp, ";", pos) = 0
            start2 = FindString(sTemp, "(") + 1
            ende2 = FindString(sTemp, ",", start2)
            const = Mid(sTemp, start2, ende2 - start2)
            AddElement(ListFindFont())
            ListFindFont()\Const = const
            ListFindFont()\Line = sTemp
          EndIf
        EndIf
        
      EndIf
      
          
    Wend
    CloseFile(0)
    
  Next
  
  
EndProcedure

; ***************************************************************************************

Procedure DoSetPrefix()

  Protected sTemp.s, prefix.s, function.s, start, ende, ende2, len, pos, pos2, index, pos3
  
  ForEach ListCommon()
    sTemp = ListCommon()
    
    ; Suche Kommentar
    pos = FindString(sTemp, ";")
    If pos > 0 And pos < 10
      Continue
    EndIf
      
    ; Suche Prefix von OpenWindow
    If FindStringEx(sTemp, "OPENWINDOW(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      prefix = Mid(sTemp, start, len)
      prefix = Trim(prefix)
      ; berprfung auf #PB_Any
      If UCase(prefix) = "PB_ANY"
        Info(" -> Error: Find OpenWindow with '#PB_Any', Not supported. Stop!")
        ProcedureReturn #False
      EndIf
      prefix + "_"
      Continue
    EndIf
    ; Suche Prefix UseGadgetList
    If FindStringEx(sTemp, "USEGADGETLIST(", 1)
      start = FindString(sTemp, "WINDOWID(", 1) + 2
      start = FindString(sTemp, "(", start) + 2
      ende = FindString(sTemp, ")", 1)
      len = ende - start
      prefix = Mid(sTemp, start, len)
      prefix = Trim(prefix)
      prefix + "_"
      Continue
    EndIf
    ; Suche CreateToolBar
    If FindStringEx(sTemp, "CREATETOOLBAR(", 1)
      start = FindString(sTemp, "(", 1) + 2
      start = FindString(sTemp, "(", start) + 2
      ende = FindString(sTemp, ")", 1)
      len = ende - start
      prefix = Mid(sTemp, start, len)
      prefix = Trim(prefix)
      prefix + "_"
      ;Continue - Fr Toolbar auch Prefix setzen
    EndIf
    ; Suche CreateStatusBar
    If FindStringEx(sTemp, "CREATESTATUSBAR(", 1)
      start = FindString(sTemp, "(", 1) + 2
      start = FindString(sTemp, "(", start) + 2
      ende = FindString(sTemp, ")", 1)
      len = ende - start
      prefix = Mid(sTemp, start, len)
      prefix = Trim(prefix)
      prefix + "_"
      ;Continue - Fr StatusBar auch Prefix setzen
    EndIf
     
    ; Ignoriere CreateGadgetList()
    If FindStringEx(sTemp, "CREATEGADGETLIST(", 1)
      Continue
    EndIf
    
    ; Ignoriere AddStatusBarField()
    If FindStringEx(sTemp, "ADDSTATUSBARFIELD(", 1)
      Continue
    EndIf
    
    ; Suche Konstanten und setze Prefix
    pos3 = 1
    Repeat
      pos = FindString(sTemp, "(#", pos3)
      If pos
        pos3 = pos + 2
        ; Prfe auf gltiges Funktion
        pos2 = FindStringLeft(sTemp, " ", pos)
        If pos2 = 0
          pos2 = FindStringLeft(sTemp, #TAB$, pos)
        EndIf
        pos2 + 1
        function = Mid(sTemp, pos2, pos - pos2)
        function = Trim(function)
        function = Trim(function, #TAB$)
        function = UCase(function)
        If FindMapElement(MapValidFunction(), function)
          ListCommon() = Left(sTemp, pos + 1) + prefix + Mid(sTemp, pos + 2)
          sTemp = ListCommon()
        EndIf
      Else
        Break
      EndIf
    ForEver
    
    ; ToolBarToolTip - Suche 2te Konstante und setze Prefix
    pos = FindStringEx(sTemp, "TOOLBARTOOLTIP(", 1)
    If pos
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, "#", pos)
      If pos
        ListCommon() = Left(sTemp, pos) + prefix + Mid(sTemp, pos + 1)
        sTemp = ListCommon()
      EndIf
    EndIf
    
    ; SplitterGadget - Suche 5te und 6te Konstante und setze Prefix
    pos = FindStringEx(sTemp, "SPLITTERGADGET(", 1)
    If pos
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, "#", pos)
      If pos
        ListCommon() = Left(sTemp, pos) + prefix + Mid(sTemp, pos + 1)
        sTemp = ListCommon()
      EndIf
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, "#", pos)
      If pos
        ListCommon() = Left(sTemp, pos) + prefix + Mid(sTemp, pos + 1)
        sTemp = ListCommon()
      EndIf
    EndIf
    
    ; MdiGadget - Suche 5te und 6te Konstante und setze Prefix
    pos = FindStringEx(sTemp, "MDIGADGET(", 1)
    If pos
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, "#", pos)
      If pos
        ListCommon() = Left(sTemp, pos) + prefix + Mid(sTemp, pos + 1)
        sTemp = ListCommon()
      EndIf
      pos = FindString(sTemp, ",", pos) + 1
      pos = FindString(sTemp, "#", pos)
      If pos
        ListCommon() = Left(sTemp, pos) + prefix + Mid(sTemp, pos + 1)
        sTemp = ListCommon()
      EndIf
    EndIf
        
  Next
  
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure DoFindConstanten()

  Protected sTemp.s, const.s, function.s, start, ende, len, pos, find, UserGadget.s
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Suche OpenWindow
    If FindStringEx(sTemp, "OPENWINDOW(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      ; Prfung auf vorhandenen WindowID Eintrag
      ForEach ListFindWindow()
        If UCase(ListFindWindow()) = UCase(const)
          Info(" -> Error: Find duplicate WindowID(#" + const + "). Stop!")
          ProcedureReturn #False
        EndIf
      Next
      AddElement(ListFindWindow())
      ListFindWindow() = const
      Continue
    EndIf
    ; Suche Menu 
    If FindStringEx(sTemp, "CREATEMENU(#", 1) Or FindStringEx(sTemp, "CREATEPOPUPMENU(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      If ende = 0
        ende = FindString(sTemp, ")", 1)
      EndIf
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      ; Prfung auf vorhandenen MenuID Eintrag
      ForEach ListFindMenu()
        If UCase(ListFindMenu()) = UCase(const)
          Info(" -> Error: Find duplicate MenuID(#" + const + "). Stop!")
          ProcedureReturn #False
        EndIf
      Next
      AddElement(ListFindMenu())
      ListFindMenu() = const
      Continue
    EndIf
    ; Suche Image Menu 
    If FindStringEx(sTemp, "CREATEIMAGEMENU(#", 1) Or FindStringEx(sTemp, "CREATEPOPUPIMAGEMENU(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      If ende = 0
        ende = FindString(sTemp, ")", 1)
      EndIf
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      ForEach ListFindMenu()
        If UCase(ListFindMenu()) = UCase(const)
          Info(" -> Error: Find duplicate MenuID(#" + const + "). Stop!")
          ProcedureReturn #False
        EndIf
      Next
      AddElement(ListFindMenu())
      ListFindMenu() = const
      Continue
    EndIf
    ; Suche MenuItem 
    If FindStringEx(sTemp, "MENUITEM(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      find = #False
      ForEach ListFindMenuItem()
        If UCase(ListFindMenuItem()) = UCase(const)
          Info(" -> Warning: Find duplicate MenuItemID(#" + const + ") by MenuItem.")
          find = #True
          Break
        EndIf
      Next
      LastElement(ListFindMenuItem())
      If Not find
        AddElement(ListFindMenuItem())
        ListFindMenuItem() = const
      EndIf
      Continue
    EndIf
    ; Suche Statusbar 
    If FindStringEx(sTemp, "CREATESTATUSBAR(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      ForEach ListFindStatusBar()
        If UCase(ListFindStatusBar()) = UCase(const)
          Info(" -> Error: Find duplicate StatusBarID(#" + const + "). Stop!")
          ProcedureReturn #False
        EndIf
      Next
      AddElement(ListFindStatusBar())
      ListFindStatusBar() = const
      Continue
    EndIf
    ; Suche Toolbar
    If FindStringEx(sTemp, "CREATETOOLBAR(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      ForEach ListFindToolBar()
        If UCase(ListFindToolBar()) = UCase(const)
          Info(" -> Error: Find duplicate ToolBarID(#" + const + "). Stop!")
          ProcedureReturn #False
        EndIf
      Next
      AddElement(ListFindToolBar())
      ListFindToolBar() = const
      Continue
    EndIf
    ; Suche ToolBarStandardButton / ToolBarImageButton (MenuItem)
    If FindStringEx(sTemp, "TOOLBARSTANDARDBUTTON(#", 1) Or FindStringEx(sTemp, "TOOLBARIMAGEBUTTON(#", 1)
      start = FindString(sTemp, "(", 1) + 2
      ende = FindString(sTemp, ",", 1)
      len = ende - start
      const = Mid(sTemp, start, len)
      const = Trim(const)
      find = #False
      ; Prfung auf vorhandenen MenuItem Eintrag
      ForEach ListFindMenuItem()
        If UCase(ListFindMenuItem()) = UCase(const)
          Info(" -> Warning: Find duplicate MenuItemID(#" + const + ") by ToolbarButton.")
          find = #True
          Break
        EndIf
      Next
      LastElement(ListFindMenuItem())
      If Not find
        AddElement(ListFindMenuItem())
        ListFindMenuItem() = const
      EndIf
      Continue
    EndIf
    
    ; Suche Gadget 
    pos = FindStringEx(sTemp, "(#", 1)
    If pos
      ; Prfe auf gltiges Gadget
      function = Left(sTemp, pos - 1)
      function = Trim(function)
      function = Trim(function, #TAB$)
      function = UCase(function)
      If FindMapElement(MapValidGadget(), function)
        start = FindString(sTemp, "(", 1) + 2
        ende = FindString(sTemp, ",", 1)
        len = ende - start
        const = Mid(sTemp, start, len)
        const = Trim(const)
        find = #False
        ; Prfung auf vorhandenen Gadget Eintrag
        ForEach ListFindGadget()
          If UCase(ListFindGadget()\Const) = UCase(const)
            find = #True
            Break
          EndIf
        Next
        If Not find
          AddElement(ListFindGadget())
          ; Schreibe GadgetID
          ListFindGadget()\Const = const
          ; Schreibe GadgetType
          ListFindGadget()\Gadget = function
        EndIf
        Continue
      EndIf
    EndIf
  Next
  
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure DoFindLoadImage()

  Protected sTemp.s, file.s, const.s, image, start, ende, len, pos, find, index, *pointer.character
  
  image = 0
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Suche LoadImage
    pos = FindStringEx(sTemp, "LOADIMAGE(", 1)
    If pos
      ; Suche Datei
      start = FindString(sTemp, Chr(34), pos) + 1
      ende = FindString(sTemp, Chr(34), start)
      len = ende - start
      file = Mid(sTemp, start, len)
      ; Prfung auf vorhandene Imagefile
      find = #False
      ForEach ListFindImage()
        If UCase(ListFindImage()\File) = UCase(file)
          find = #True
          const = ListFindImage()\Const
          Break
        EndIf
      Next
      If Not find
        const = "#MyImage_" + Str(image)
        AddElement(ListFindImage())
        ListFindImage()\File = file
        ListFindImage()\Const = const
        image + 1
      EndIf
      ; Setze Variable
      start = pos - 1
      ende = FindString(sTemp, ")", pos) + 1
      ListCommon() = Left(sTemp, start) + "ImageID(" + const + ")" + Mid(sTemp, ende)
    EndIf  
  Next

EndProcedure

; ***************************************************************************************

Procedure DoFindImageNull()

  Protected sTemp.s, image.s, const.s, start, ende, len, pos, find, num
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Suche ImageBut
    pos = FindStringEx(sTemp, "IMAGEGADGET(#", 1)
    If pos
      ; Suche Para
      start = pos
      For num = 1 To 5
        start = FindString(sTemp, ",", start) + 1
      Next
      ListCommon() = Left(sTemp, start) + "0)"
    EndIf  
  Next

EndProcedure

; ***************************************************************************************

Procedure DoSetLanguage()

  Protected sTemp.s, text.s, const.s, start, ende, len, pos, find, num 
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Ignorriere OpenWindow und LoadImage
    If FindStringEx(sTemp, "OPENWINDOW(", 1) Or FindStringEx(sTemp, "LOADIMAGE(", 1) Or FindStringEx(sTemp, "CATCHIMAGE(", 1)
      Continue
    EndIf
    pos = FindString(sTemp, #DQUOTE$, 1)
    If pos
      ; Suche String
      start = pos + 1
      ende = FindString(sTemp, #DQUOTE$, start)
      len = ende - start
      text = Mid(sTemp, start, len)
      ; Setze Variable
      start = pos - 1
      ende = pos + len + 2
      ListCommon() = Left(sTemp, start) + "MyLanguage(" + #DQUOTE$ + text + #DQUOTE$ + ")" + Mid(sTemp, ende, 256)
    EndIf  
  Next
  
  
EndProcedure

; ***************************************************************************************

Procedure DoSearchLanguage(List MyList.s())
  
  Protected sTemp.s, const.s, start, ende, len
  
  ; Datei Common
  ForEach MyList()
    sTemp = MyList()
    start = FindStringEx(sTemp, "MyLanguage(")
    If start
      start = FindString(sTemp, #DQUOTE$) + 1
      ende = FindString(sTemp, #DQUOTE$, start)
      len = ende - start
      If len > 0
        const = Mid(sTemp, start, len)
        If FindMapElement(MapLanguage(), const) = 0
          MapLanguage(const) = const
        EndIf
      EndIf
    EndIf
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoFindLanguage()
  
  Protected file.s, ft
  
  ; Datei CommonFile
  DoSearchLanguage(ListCommon())
  ; Datei Main
  DoSearchLanguage(ListFileMain())
  ; Datei EventMenu
  DoSearchLanguage(ListFileEventMenu())
  ; Datei EventGadget
  DoSearchLanguage(ListFileEventGadget())
  ; Datei EventWindow
  DoSearchLanguage(ListFileEventWindow())
  
  ForEach ListIncludeFiles()
    ClearList(ListFileInclude())
    file = ListIncludeFiles()
    ; Datei laden
    If OpenFile(0, ListIncludeFiles())
      If ReadStringFormat(0) <> #PB_Ascii
       ft = #PB_UTF8
      Else 
       ft = #PB_Ascii
      EndIf
      While Eof(0) = 0
        AddElement(ListFileInclude())
        ListFileInclude() = ReadString(0, ft)
      Wend
      CloseFile(0)
    Else
      Info(" -> Error OpenFile " + ListIncludeFiles() + " / " + FormatMessage(GetLastError_()))
      Continue
    EndIf
    ; Suchen
    DoSearchLanguage(ListFileInclude())
    
  Next

  
EndProcedure

; ***************************************************************************************

Procedure DoSetParendWindow()

  Protected sTemp.s, sTemp3.s, const.s, start, ende, len, index
  Dim text.s(10)
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Suche Erste OpenWindow
    If start = 0
      If FindStringEx(sTemp, "OPENWINDOW(#", 1)
        start = FindString(sTemp, "(", 1) + 1
        ende = FindString(sTemp, ",", 1)
        len = ende - start
        const = Mid(sTemp, start, len)
        const = Trim(const)
      EndIf
    Else
      If FindStringEx(sTemp, "OPENWINDOW(#", 1)
        start = FindString(sTemp, "(", 1) + 1
        ende = FindStringLeft(sTemp, ")")
        len = ende - start
        text(0) = Mid(sTemp, start, len)
        For index = 1 To 10
          text(index) = StringField(text(0), index, ",")
        Next index
        If text(7) = ""
          sTemp3 = text(1) + "," + text(2) + "," + text(3) + "," + text(4) + "," + text(5) + "," + text(6) + ", PB_Any, WindowID(" + const + ")"
        Else
          sTemp3 = text(1) + "," + text(2) + "," + text(3) + "," + text(4) + "," + text(5) + "," + text(6) + "," + text(7) + ", WindowID(" + const + ")"
        EndIf
        ListCommon() = Left(sTemp, start - 1) + sTemp3 + Mid(sTemp, ende, 256)
        For index = 0 To 10
          text(index) = ""
        Next index
      EndIf
    EndIf
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoSetPB_Ignore()

  Protected sTemp.s, start, zw, ende
  
  ForEach ListCommon()
    sTemp = ListCommon()
    If FindStringEx(sTemp, "OPENWINDOW(#", 1)
      start = FindString(sTemp, ",", 1) + 1
      zw = FindString(sTemp, ",", start) + 1
      ende = FindString(sTemp, ",", zw) + 1
      ListCommon() = Left(sTemp, start - 1) + " #PB_Ignore, #PB_Ignore," + Mid(sTemp, ende, 256)
    EndIf
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateEnumeration()

  Protected sTemp.s
  
  ; Window
  AddElement(ListEnumeration())
  ListEnumeration() = ";- Window Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindWindow()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindWindow()
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; Menu
  AddElement(ListEnumeration())
  ListEnumeration() = ";- Menubar Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindMenu()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindMenu()
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; MenuItem
  AddElement(ListEnumeration())
  ListEnumeration() = ";- MenuItem Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindMenuItem()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindMenuItem()
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; Gadget
  AddElement(ListEnumeration())
  ListEnumeration() = ";- Gadget Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindGadget()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindGadget()\Const
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; Statusbar
  AddElement(ListEnumeration())
  ListEnumeration() = ";- StatusBar Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindStatusBar()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindStatusBar()
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; ToolBar
  AddElement(ListEnumeration())
  ListEnumeration() = ";- ToolBar Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindToolBar()
    AddElement(ListEnumeration())
    ListEnumeration() = "  #" + ListFindToolbar()
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; Fonts
  AddElement(ListEnumeration())
  ListEnumeration() = ";- Font Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindFont()
    AddElement(ListEnumeration())
    ListEnumeration() = "  " + ListFindFont()\Const
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
  ; Images
  AddElement(ListEnumeration())
  ListEnumeration() = ";- Image Constants"
  AddElement(ListEnumeration())
  ListEnumeration() = "Enumeration"
  ForEach ListFindImage()
    AddElement(ListEnumeration())
    ListEnumeration() = "  " + ListFindImage()\Const
  Next
  AddElement(ListEnumeration())
  ListEnumeration() = "EndEnumeration"
  AddElement(ListEnumeration())
  ListEnumeration() = ""
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateImage()

  Protected sTemp.s, const.s, ext.s, find
  
  ; Kopf
  sTemp = ";- Image Plugin"
  AddElement(ListImage())
  ListImage() = sTemp
  AddElement(ListImage())
  ListImage() = ""
  ; Add ImagePlugin JPG
  find = #False
  ForEach ListFindImage()
    ext = UCase(GetExtensionPart(ListFindImage()\file))
    If ext = "JPG" Or ext = "JPEG"
      AddElement(ListImage())
      ListImage() = "UseJPEGImageDecoder()"
      AddElement(ListImage())
      ListImage() = "UseJPEG2000ImageDecoder()"
      find = #True
      Break
    EndIf
  Next
  ; Add ImagePlugin PNG
  ForEach ListFindImage()
    ext = UCase(GetExtensionPart(ListFindImage()\file))
    If ext = "PNG"
      AddElement(ListImage())
      ListImage() = "UsePNGImageDecoder()"
      find = #True
      Break
    EndIf
  Next
  ; Add ImagePlugin Tiff
  ForEach ListFindImage()
    ext = UCase(GetExtensionPart(ListFindImage()\file))
    If ext = "TIF" Or ext = "TIFF"
      AddElement(ListImage())
      ListImage() = "UseTIFFImageDecoder()"
      find = #True
      Break
    EndIf
  Next
  ; Add ImagePlugin TGA
  ForEach ListFindImage()
    ext = UCase(GetExtensionPart(ListFindImage()\file))
    If ext = "TGA"
      AddElement(ListImage())
      ListImage() = "UseTGAImageDecoder()"
      find = #True
      Break
    EndIf
  Next
  If find
    AddElement(ListImage())
    ListImage() = ""
  EndIf
        
  If Switch\Image_Include
    ; Catch
    sTemp = ";- Catch Images"
    AddElement(ListImage())
    ListImage() = sTemp
    ForEach ListFindImage()
      const = ListFindImage()\Const
      sTemp = "CatchImage(" + const + ", ?" + Mid(const,2) + ")"
      AddElement(ListImage())
      ListImage() = sTemp
    Next
    AddElement(ListImage())
    ListImage() = ""
    ; Images
    sTemp = ";- Images"
    AddElement(ListImage())
    ListImage() = sTemp
    sTemp = "DataSection"
    AddElement(ListImage())
    ListImage() = sTemp
    ForEach ListFindImage()
      const = ListFindImage()\Const
      sTemp = "  " + Mid(const,2) + ":"
      AddElement(ListImage())
      ListImage() = sTemp
      sTemp = "  IncludeBinary " + Chr(34) + ListFindImage()\File + Chr(34)
      AddElement(ListImage())
      ListImage() = sTemp
    Next
    sTemp = "EndDataSection"
    AddElement(ListImage())
    ListImage() = sTemp
  Else
    ; Load
    sTemp = ";- Load Images"
    AddElement(ListImage())
    ListImage() = sTemp
    ForEach ListFindImage()
      const = ListFindImage()\Const
      sTemp = "LoadImage(" + const + ", " + Chr(34) + ListFindImage()\File + Chr(34) + ")"
      AddElement(ListImage())
      ListImage() = sTemp
    Next
    AddElement(ListImage())
    ListImage() = ""
    
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateFont()
  
  Protected sTemp.s
  
  ; Kopf
  sTemp = ";- Load Font"
  AddElement(ListFont())
  ListFont() = sTemp
  ForEach ListFindFont()
    AddElement(ListFont())
    ListFont() = ListFindFont()\Line
  Next
  AddElement(ListFont())
  ListFont() = ""
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateLanguage()

  Protected sTemp.s, num
  
  ForEach ListFileLang()
    If FindString(ListFileLang(), "#MaxLanguage =", 1)
      ListFileLang() = "#MaxLanguage = " + Str(MapSize(MapLanguage()))
    EndIf
    If FindString(ListFileLang(), "DefaultLanguage:", 1)
      Break
    EndIf
  Next
  ; Vorhandene Eintrge lschen
  Repeat
    NextElement(ListFileLang())
    sTemp = ListFileLang()
    If FindString(sTemp , "EndDefaultLanguage:", 1) Or FindString(sTemp , "EndDataSection", 1)
      Break
    EndIf
    DeleteElement(ListFileLang())
  Until #False
  PreviousElement(ListFileLang())
  ForEach MapLanguage()
    AddElement(ListFileLang())
    ListFileLang() = "  Data.s " + #DQUOTE$ + MapKey(MapLanguage()) + #DQUOTE$
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateMenuItemTabs()

  Protected sTemp.s, const.s
  
  const = #DQUOTE$ + " + #TAB$ + " + #DQUOTE$
  
  ForEach ListCommon()
    sTemp = ListCommon()
    ; Suche MenuItem 
    If FindStringEx(sTemp, "MENUITEM(#", 1)
      ListCommon() = ReplaceString(sTemp, "\t", const, #PB_String_NoCase)
      Continue
    EndIf
        
  Next

EndProcedure

; ***************************************************************************************

Procedure DoLoadFiles()

  Protected sTemp.s, sEintrag.s, sText.s, line.s, start, ende, pos, len, path.s, file.s, ft
  
  ; Init
  path = GetPathPart(path_project)
  
  ; Main
  file = path + "Main.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      AddElement(ListFileMain())
      ListFileMain() = sTemp
    Wend
    CloseFile(0)
  Else
    Restore Main
    Read.s sTemp
    sTemp = RemoveString(sTemp, #CR$)
    start = 1
    While start
      ende = FindString(sTemp, #LF$, start)
      len = ende - start
      If len >= 0
        AddElement(ListFileMain())
        ListFileMain() = Mid(sTemp, start, len)
        start = ende + 1
      Else
        Break
      EndIf
    Wend
  EndIf
  
  ; EventMain
  If Switch\MacMenuEvents
    Restore EventMainDataMac
  Else
    Restore EventMainData
  EndIf  

  Read.s sTemp
  sTemp = RemoveString(sTemp, #CR$)
  start = 1
  While start
    ende = FindString(sTemp, #LF$, start)
    len = ende - start
    If len >= 0
      AddElement(ListFileEventMain())
      ListFileEventMain() = Mid(sTemp, start, len)
      start = ende + 1
    Else
      Break
    EndIf
  Wend
  
  ; Language
  file = path + "LoadLanguage.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      AddElement(ListFileLang())
      ListFileLang() = sTemp
    Wend
    CloseFile(0)
  Else
    ; Standard laden wenn Datei nicht vorhanden
    Restore Language
    Read.s sTemp
    sTemp = RemoveString(sTemp, #CR$)
    start = 1
    While start
      ende = FindString(sTemp, #LF$, start)
      len = ende - start
      If len >= 0
        AddElement(ListFileLang())
        ListFileLang() = Mid(sTemp, start, len)
        start = ende + 1
      Else
        Break
      EndIf
    Wend
  EndIf
  
  ; EventMenu
  file = path + "EventMenu.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      AddElement(ListFileEventMenu())
      ListFileEventMenu() = sTemp
    Wend
    CloseFile(0)
  EndIf
  While ListSize(ListFileEventMenu())
    LastElement(ListFileEventMenu())
    If Left(ListFileEventMenu(), 1) = ";"
      DeleteElement(ListFileEventMenu())
    Else
      Break
    EndIf
  Wend
  
  ; EventGadget
  file = path + "EventGadget.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      AddElement(ListFileEventGadget())
      ListFileEventGadget() = sTemp
    Wend
    CloseFile(0)
  EndIf
  While ListSize(ListFileEventGadget())
    LastElement(ListFileEventGadget())
    If Left(ListFileEventGadget(), 1) = ";"
      DeleteElement(ListFileEventGadget())
    Else
      Break
    EndIf
  Wend
  
  ; EventWindow
  file = path + "EventWindow.pb"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    While Eof(0) = 0
      sTemp = ReadString(0, ft)
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
    Wend
    CloseFile(0)
  EndIf
  While ListSize(ListFileEventWindow())
    LastElement(ListFileEventWindow())
    If Left(ListFileEventWindow(), 1) = ";"
      DeleteElement(ListFileEventWindow())
    Else
      Break
    EndIf
  Wend
  
  ; Catalog
  file = path + "Catalog"
  If ReadFile(0, file)
    ft = ReadStringFormat(0)
    If Not Eof(0)
      sTemp = ReadString(0, ft)
    EndIf
    While Not Eof(0)
      sTemp = ReadString(0, ft)
      sEintrag = StringField(sTemp, 1, ";")
      sEintrag = Trim(sEintrag, #DQUOTE$)
      If sEintrag
        sText = StringField(sTemp, 2, ";")
        sText = Trim(sText, #DQUOTE$)
        If sText
          MapLanguage(sEintrag) = sText
        Else
          MapLanguage(sEintrag) = sEintrag
        EndIf
      EndIf
    Wend
    CloseFile(0)
  EndIf

  
EndProcedure

; ***************************************************************************************

Procedure DoCreateMain()

  Protected sTemp.s, sTemp2.s, pos, find, prog_init.s, prog_open
  
  FirstElement(ListFindWindow())
  sTemp = "Open_" + ListFindWindow() + "()"

  ForEach ListFileMain()
    If FindString(ListFileMain(), "Open_WindowXY()")
      ListFilemain() = ReplaceString(ListFilemain(), "Open_WindowXY()", sTemp, #PB_String_NoCase)
      Continue
    EndIf
    If FindString(ListFileMain(), "If WindowID(#", 1)
      ListFileMain() = "  If WindowID(#" + ListFindWindow() + ")"
      Continue
    EndIf
  Next
  
  ; Mac Menu suchen
  pos = 0
  ForEach ListFileMain()
    If FindString(ListFileMain(), "CompilerIf #PB_Compiler_OS = #PB_OS_MacOS", 1)
      pos = 1
      Continue
    EndIf
    If pos
      If FindString(ListFileMain(), "MenuItem(#PB_Menu_Quit")
        find = #True
        Break
      ElseIf FindString(ListFileMain(), "CompilerEndIf")
        pos = 0
      EndIf
    EndIf
  Next
  ; Mac Menu eintragen
  If Switch\MacMenuEvents And Not find
    FirstElement(ListFindMenu())
    ForEach ListFileMain()
      If FindString(ListFileMain(), "If WindowID(#", 1)
        AddElement(ListFileMain())
        ListFileMain() = "    "
        AddElement(ListFileMain())
        ListFileMain() = "    CompilerIf #PB_Compiler_OS = #PB_OS_MacOS"
        FirstElement(ListFindWindow())
        AddElement(ListFileMain())
        ListFileMain() = "      If Not IsMenu(#" + ListFindWindow() + ")"
        AddElement(ListFileMain())
        ListFileMain() = "        CreateMenu(0, WindowID(#" + ListFindWindow() + "))"
        AddElement(ListFileMain())
        ListFileMain() = "      EndIf"
        AddElement(ListFileMain())
        ListFileMain() = "      MenuItem(#PB_Menu_About, " + #DQUOTE$ + #DQUOTE$ + ")"
        AddElement(ListFileMain())
        ListFileMain() = "      MenuItem(#PB_Menu_Preferences, " + #DQUOTE$ + #DQUOTE$ + ")"
        AddElement(ListFileMain())
        ListFileMain() = "      MenuItem(#PB_Menu_Quit, " + #DQUOTE$ + #DQUOTE$ + ")"
        AddElement(ListFileMain())
        ListFileMain() = "    CompilerEndIf"
        Break
      EndIf
    Next
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateCommon()

  Protected sTemp.s
  
  AddElement(ListFileCommon()) : ListFileCommon() = ";-TOP"
  AddElement(ListFileCommon()) : ListFileCommon() = ""
  AddElement(ListFileCommon()) : ListFileCommon() = "; Event Designer -  Commonfile (Do Not Edit - Allways Overwrite)"
  
  AddListTrenn(ListFileCommon())
  
  AddElement(ListFileCommon()) : ListFileCommon() = "Procedure MyEventResizeGadget(Gadget, x, y, width, height)"
  AddElement(ListFileCommon()) : ListFileCommon() = "  If IsGadget(Gadget)"
  AddElement(ListFileCommon()) : ListFileCommon() = "    ResizeGadget(Gadget, x, y, width, height)"
  AddElement(ListFileCommon()) : ListFileCommon() = "  EndIf"
  AddElement(ListFileCommon()) : ListFileCommon() = "EndProcedure"
  AddElement(ListFileCommon()) : ListFileCommon() = ""
  AddElement(ListFileCommon()) : ListFileCommon() = "Macro ResizeGadget(Gadget, x, y, width, height)"
  AddElement(ListFileCommon()) : ListFileCommon() = "  MyEventResizeGadget(Gadget, x, y, width, height)"
  AddElement(ListFileCommon()) : ListFileCommon() = "EndMacro"
  
  AddListTrenn(ListFileCommon())
  
  ForEach ListEnumeration()
    AddElement(ListFileCommon())
    ListFileCommon() = ListEnumeration()
  Next
  
  AddListTrenn(ListFileCommon())
  
  ForEach ListFont()
    AddElement(ListFileCommon())
    ListFileCommon() = ListFont()
  Next
  
  ForEach ListImage()
    AddElement(ListFileCommon())
    ListFileCommon() = ListImage()
  Next
  
  AddListTrenn(ListFileCommon())

  If Switch\Multilang
    AddElement(ListFileCommon())
    ListFileCommon() = "IncludeFile " + Chr(34) + "LoadLanguage.pb" + Chr(34)
    AddListTrenn(ListFileCommon())
  EndIf
  
  ForEach ListCommon()
    AddElement(ListFileCommon())
    ListFileCommon() = ListCommon()
  Next
  
  AddElement(ListFileCommon()) : ListFileCommon() = "UndefineMacro ResizeGadget"
  
  AddListTrenn(ListFileCommon())
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateEventMain()

  Protected sTemp.s
  
  ; Setze CallEventMenuCount
  ForEach ListFileEventMain()
    If FindString(ListFileEventMain(), "#CallEventMenuCount = 0", 1)
      ListFileEventMain() = "#CallEventMenuCount = " + Str(ListSize(ListFindMenuItem()))
      Break
    EndIf
  Next
  
  ; Setze CallEventGadgetCount
  ForEach ListFileEventMain()
    If FindString(ListFileEventMain(), "#CallEventGadgetCount = 0", 1)
      ListFileEventMain() = "#CallEventGadgetCount = " + Str(ListSize(ListFindGadget()))
      Break
    EndIf
  Next
  
  ; Setze CallEventWindowCount
  ForEach ListFileEventMain()
    If FindString(ListFileEventMain(), "#CallEventWindowCount = 0", 1)
      ListFileEventMain() = "#CallEventWindowCount = " + Str(ListSize(ListFindWindow()))
      Break
    EndIf
  Next
  
  ; DataSection Begin
  ForEach ListFileEventMain()
    If FindString(ListFileEventMain(), "DataSection", 1)
      Break
    EndIf
  Next
  
  ; DataSection EventMenu
  sTemp = "  CallEventMenu:"
  AddElement(ListFileEventMain())
  ListFileEventMain() = sTemp
  ForEach ListFindMenuItem()
    sTemp = "    Data.i @EventMenu_" + ListFindMenuItem() + "()"
    AddElement(ListFileEventMain())
    ListFileEventMain() = sTemp
  Next
  
  ; DataSection EventGadget
  sTemp = "  CallEventGadget:"
  AddElement(ListFileEventMain())
  ListFileEventMain() = sTemp
  ForEach ListFindGadget()
    If ListFindGadget()\Gadget = "TEXTGADGET"
      sTemp = "    Data.i @MyEventDispatch()"
      AddElement(ListFileEventMain())
      ListFileEventMain() = sTemp
      Continue
    EndIf
    If ListFindGadget()\Gadget = "FRAME3DGADGET" Or ListFindGadget()\Gadget = "FRAMEGADGET"
      sTemp = "    Data.i @MyEventDispatch()"
      AddElement(ListFileEventMain())
      ListFileEventMain() = sTemp
      Continue
    EndIf
    sTemp = "    Data.i @EventGadget_" + ListFindGadget()\Const + "()"
    AddElement(ListFileEventMain())
    ListFileEventMain() = sTemp
  Next
  
  ; DataSetion EventSize
  sTemp = "  CallEventSize:"
  AddElement(ListFileEventMain())
  ListFileEventMain() = sTemp
  ForEach ListFindWindow()
    sTemp = "    Data.i @EventSize_" + ListFindWindow() + "()"
    AddElement(ListFileEventMain())
    ListFileEventMain() = sTemp
  Next
  
  ; DataSetion EventExit
  sTemp = "  CallEventExit:"
  AddElement(ListFileEventMain())
  ListFileEventMain() = sTemp
  ForEach ListFindWindow()
    sTemp = "    Data.i @EventExit_" + ListFindWindow() + "()"
    AddElement(ListFileEventMain())
    ListFileEventMain() = sTemp
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateEventMenu()

  Protected sTemp.s, find
  
  ; Kopf erzeugen
  If ListSize(ListFileEventMenu()) = 0
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = ";-TOP"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = ""
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = "; Event Designer -  Event Menu"
    AddListTrenn(ListFileEventMenu())
  EndIf
  
  ForEach ListFindMenuItem()
    sTemp = "Procedure EventMenu_" + ListFindMenuItem() + "()"
    ForEach ListFileEventMenu()
      If FindString(ListFileEventMenu(), sTemp, 1)
        find = 1
        Break
      EndIf
    Next
    If find
      find = 0
    Else
      AddElement(ListFileEventMenu())
      ListFileEventMenu() = sTemp
      sTemp = "  "
      AddElement(ListFileEventMenu())
      ListFileEventMenu() = sTemp
      sTemp = "EndProcedure"
      AddElement(ListFileEventMenu())
      ListFileEventMenu() = sTemp
      AddListTrenn(ListFileEventMenu())
    EndIf    
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateMacEventMenu()

  Protected sTemp.s, find
  
  ; Kopf erzeugen
  If ListSize(ListFileEventMenu()) = 0
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = ";-TOP"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = ""
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = "; Event Designer -  Event Menu"
    AddListTrenn(ListFileEventMenu())
  EndIf
  
  sTemp = "Procedure EventMenu_MacAbout()"
  ForEach ListFileEventMenu()
    If FindString(ListFileEventMenu(), sTemp, 1)
      find = 1
      Break
    EndIf
  Next
  If find
    find = 0
  Else
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "  "
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "EndProcedure"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    AddListTrenn(ListFileEventMenu())
  EndIf    

  sTemp = "Procedure EventMenu_MacPreferences()"
  ForEach ListFileEventMenu()
    If FindString(ListFileEventMenu(), sTemp, 1)
      find = 1
      Break
    EndIf
  Next
  If find
    find = 0
  Else
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "  "
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "EndProcedure"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    AddListTrenn(ListFileEventMenu())
  EndIf    

  sTemp = "Procedure EventMenu_MacQuit()"
  ForEach ListFileEventMenu()
    If FindString(ListFileEventMenu(), sTemp, 1)
      find = 1
      Break
    EndIf
  Next
  If find
    find = 0
  Else
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "  ExitApplication = 1"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    sTemp = "EndProcedure"
    AddElement(ListFileEventMenu())
    ListFileEventMenu() = sTemp
    AddListTrenn(ListFileEventMenu())
  EndIf    

EndProcedure

; ***************************************************************************************

Procedure DoCreateEventSize()

  Protected sTemp.s, find
  
  ; Kopf erzeugen
  If ListSize(ListFileEventWindow()) = 0
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = ";-TOP"
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = ""
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = "; Event Designer -  Event Window"
    AddListTrenn(ListFileEventWindow())
  EndIf
  
  ForEach ListFindWindow()
    sTemp = "Procedure EventSize_" + ListFindWindow() + "()"
    ForEach ListFileEventWindow()
      If FindString(ListFileEventWindow(), sTemp, 1)
        find = 1
        Break
      EndIf
    Next
    If find
      find = 0
    Else
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = "  "
      
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = "  CompilerIf Defined(Resize_" + ListFindWindow() + ", #PB_Procedure)"
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = "    Resize_" + ListFindWindow()+ "()"
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = "  CompilerEndIf"
      
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = "  "
      sTemp = "EndProcedure"
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
      AddListTrenn(ListFileEventWindow())
    EndIf    
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateEventExit()

  Protected sTemp.s, find, parend
  
  ; Kopf erzeugen
  If ListSize(ListFileEventWindow()) = 0
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = ";-TOP"
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = ""
    AddElement(ListFileEventWindow())
    ListFileEventWindow() = "; Event Designer -  Event Window"
    AddListTrenn(ListFileEventWindow())
  EndIf
  
  ForEach ListFindWindow()
    sTemp = "Procedure EventExit_" + ListFindWindow() + "()"
    ForEach ListFileEventWindow()
      If FindString(ListFileEventWindow(), sTemp, 1)
        find = 1
        Break
      EndIf
    Next
    If find
      find = 0
    Else
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
      If parend
        sTemp = "  CloseWindow(#" + ListFindWindow() + ")"
      Else
        sTemp = "  ExitApplication = 1"
      EndIf
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
      sTemp = "EndProcedure"
      AddElement(ListFileEventWindow())
      ListFileEventWindow() = sTemp
      AddListTrenn(ListFileEventWindow())
    EndIf
    parend = #True
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateGadgetCode(List List.s(), Gadget.s)

  Protected sTemp.s
  
  ; Zeile 2
  sTemp = "  "
  AddElement(List())
  List() = sTemp
  ; Zeile 3
  sTemp = "  Select EventType()"
  AddElement(List())
  List() = sTemp
  ; Zeile 4
  sTemp = "    Case #PB_EventType_LeftClick"
  AddElement(List())
  List() = sTemp
  ; Zeile 5
  sTemp = "      "
  AddElement(List())
  List() = sTemp
  ; Zeile 6
  sTemp = "  EndSelect"
  AddElement(List())
  List() = sTemp
  ; Zeile 7
  sTemp = "  "
  AddElement(List())
  List() = sTemp
  ; Zeile 8
  sTemp = "EndProcedure"
  AddElement(List())
  List() = sTemp
  
EndProcedure

; ***************************************************************************************

Procedure DoCreateEventGadget()

  Protected sTemp.s, find, parend
  
  ; Kopf erzeugen
  If ListSize(ListFileEventGadget()) = 0
    AddElement(ListFileEventGadget())
    ListFileEventGadget() = ";-TOP"
    AddElement(ListFileEventGadget())
    ListFileEventGadget() = ""
    AddElement(ListFileEventGadget())
    ListFileEventGadget() = "; Event Designer -  Event Gadget"
    AddListTrenn(ListFileEventGadget())
  EndIf
  
  ForEach ListFindGadget()
    If ListFindGadget()\Gadget = "TEXTGADGET"
      Continue
    EndIf
    If ListFindGadget()\Gadget = "FRAME3DGADGET"
      Continue
    EndIf
    
    sTemp = "Procedure EventGadget_" + ListFindGadget()\Const + "()"
    ForEach ListFileEventGadget()
      If FindString(ListFileEventGadget(), sTemp, 1)
        find = 1
        Break
      EndIf
    Next
    If find
      find = 0
    Else
      ; Kopf EventGadget
      AddElement(ListFileEventGadget())
      ListFileEventGadget() = sTemp
      ; Default Code
      DoCreateGadgetCode(ListFileEventGadget(), ListFindGadget()\Gadget)
      AddListTrenn(ListFileEventGadget())
    EndIf    
  Next
  
EndProcedure

; ***************************************************************************************

Procedure DoMakeBackup()

  Protected path.s, path_copy.s
  
  path = GetPathPart(path_project)
  path_copy = path + "Backup"
  CreateDirectory(path_copy)
  If CopyDirectory(path, path_copy, "*.pb*") = 0
   Info("- Error CopyDirectory")
  EndIf
  
EndProcedure

; ***************************************************************************************

Procedure DoWriteFiles()

  Protected path.s, file.s, sTemp.s, num, ft
  
  path = GetPathPart(path_project)
  ft = FormatFile
    
  ; Main
  file = path + "Main.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileMain()
      WriteStringN(0, ListFileMain(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  ; Commonfile
  file = path + "CommonFile.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileCommon()
      WriteStringN(0, ListFileCommon(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  ; EventMain
  file = path + "EventMain.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileEventMain()
      WriteStringN(0, ListFileEventMain(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  ; EventMenu
  file = path + "EventMenu.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileEventMenu()
      WriteStringN(0, ListFileEventMenu(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  ; EventGadget
  file = path + "EventGadget.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileEventGadget()
      WriteStringN(0, ListFileEventGadget(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  ; EventWindow
  file = path + "EventWindow.pb"
  If CreateFile(0, file)
    Info(" -> Write File " + file)
    WriteStringFormat(0, ft)
    ForEach ListFileEventWindow()
      WriteStringN(0, ListFileEventWindow(), ft)
    Next
    CloseFile(0)
  Else
    Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
  EndIf
  If Switch\Multilang
    ; LoadLanguage
    file = path + "LoadLanguage.pb"
    If CreateFile(0, file)
      Info(" -> Write File " + file)
      WriteStringFormat(0, ft)
      ForEach ListFileLang()
        WriteStringN(0, ListFileLang(), ft)
      Next
      CloseFile(0)
    Else
      Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
    EndIf
    ; Catalog
    file = path + "Catalog"
    If CreateFile(0, file)
      Info(" -> Write File " + file)
      WriteStringFormat(0, ft)
      WriteStringN(0, "Default;Language", ft)
      ForEach MapLanguage()
        sTemp = MapKey(MapLanguage())
        If sTemp = MapLanguage()
          stemp = #DQUOTE$ + sTemp + #DQUOTE$ + ";" + #DQUOTE$ + #DQUOTE$
        Else
          stemp = #DQUOTE$ + sTemp + #DQUOTE$ + ";" + #DQUOTE$ + MapLanguage() + #DQUOTE$
        EndIf  
        WriteStringN(0, sTemp, ft)
      Next
      CloseFile(0)
    Else
      Info(" -> Error File " + file + " / " + FormatMessage(GetLastError_()))
    EndIf
  EndIf
    
EndProcedure

; ***************************************************************************************

Procedure Check_Window()

  Protected sTemp.s, find, index, count, result
  
  ; "Checkliste lschen"
  ClearList(ListCheckAlt())
  ClearList(ListCheckNeu())
  ClearList(ListCheck())
  
  ; "Liste Alt fllen"
  ForEach ListOldWindow()
    sTemp = ListOldWindow()
    ForEach ListFindWindow()
      If ListFindWindow() = sTemp
        find = #True
        Break
      Else
        find = #False
      EndIf
    Next
    If Not find
      AddElement(ListCheckAlt())
      ListCheckAlt() = sTemp
    EndIf
  Next
  ; "Liste Neu fllen"
  ForEach ListFindWindow()
    sTemp = ListFindWindow()
    ForEach ListOldWindow()
      If ListOldWindow() = sTemp
        find = #True
        Break
      Else
        find = #False
      EndIf
    Next
    If Not find
      AddElement(ListCheckNeu())
      ListCheckNeu() = sTemp
    EndIf
  Next
  
  
  If ListSize(ListCheckAlt())
    ; "Open Check"
    result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvOpenCheck, 1)  
    
    If result = #PB_MessageRequester_Cancel
      ;CloseWindow(#Check)
      result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      ProcedureReturn #False
    EndIf
    count = CountGadgetItems(#Check_Listview_ausf)
    If count = 0
      ;CloseWindow(#Check)
      result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      ProcedureReturn #True
    EndIf
    
    count - 1 
    For index = 0 To Count
      sTemp = GetGadgetItemText(#Check_listview_ausf, index, 0)
      AddElement(ListCheck())
      ListCheck()\alt = Trim(StringField(sTemp, 1, ">"))
      ListCheck()\neu = Trim(StringField(sTemp, 2, ">"))
      ListCheck()\type = 1
    Next 
  Else
    ProcedureReturn #True
  EndIf 
  ;CloseWindow(#Check)
  result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure Check_Sub(type)
  
  Protected sTemp.s, neu.s, find, index, count, len, result
  
  ; "Checkliste lschen"
  ClearList(ListCheckAlt())
  ClearList(ListCheckNeu())
  
  ; List korrigieren WindowID
  ForEach ListCheck()
    If ListCheck()\type = 1
      sTemp = ListCheck()\alt + "_"
      neu = ListCheck()\neu + "_"
      len = Len(sTemp)
      ForEach ListOld()
        If Left(ListOld(), len) = sTemp
          ListOld() = neu + Mid(ListOld(), len + 1)
        EndIf
      Next
    EndIf
  Next
  
  ; "Liste Alt fllen"
  ForEach ListOld()
    sTemp = ListOld()
    ForEach ListFind()
      If ListFind() = sTemp
        find = #True
        Break
      Else
        find = #False
      EndIf
    Next
    If Not find
      AddElement(ListCheckAlt())
      ListCheckAlt() = sTemp
    EndIf
  Next
  ; "Liste Neu fllen"
  ForEach ListFind()
    sTemp = ListFind()
    ForEach ListOld()
      If ListOld() = sTemp
        find = #True
        Break
      Else
        find = #False
      EndIf
    Next
    If Not find
      AddElement(ListCheckNeu())
      ListCheckNeu() = sTemp
    EndIf
  Next
  
  
  If ListSize(ListCheckAlt())
    ; "Open Check"
    result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvOpenCheck, type)
      
    If result = #PB_MessageRequester_Cancel
      ;CloseWindow(#Check)
      result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      ProcedureReturn #False
    EndIf
    
    count = CountGadgetItems(#Check_Listview_ausf)
    If count = 0
      ;CloseWindow(#Check)
      result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      ProcedureReturn #True
    EndIf
    
    count - 1 
    For index = 0 To Count
      sTemp = GetGadgetItemText(#Check_listview_ausf, index, 0)
      AddElement(ListCheck())
      ListCheck()\alt = Trim(StringField(sTemp, 1, ">"))
      ListCheck()\neu = Trim(StringField(sTemp, 2, ">"))
      ListCheck()\type = type
    Next 
  Else
    ProcedureReturn #True
  EndIf 
  ;CloseWindow(#Check)
  result = SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseCheck, 0)  
      
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure Check_Menu()

  ; Listen kopieren
  ClearList(ListOld())
  ForEach ListOldMenu()
    AddElement(ListOld())
    ListOld() = ListOldMenu()
  Next
  ClearList(ListFind())
  ForEach ListFindMenu()
    AddElement(ListFind())
    ListFind() = ListFindMenu()
  Next
  
  ProcedureReturn Check_Sub(2)
  
EndProcedure

; ***************************************************************************************

Procedure Check_MenuItem()

  ; Liste kopieren
  ClearList(ListOld())
  ForEach ListOldMenuItem()
    AddElement(ListOld())
    ListOld() = ListOldMenuItem()
  Next
  ClearList(ListFind())
  ForEach ListFindMenuItem()
    AddElement(ListFind())
    ListFind() = ListFindMenuItem()
  Next
  
  ProcedureReturn Check_Sub(3)
  
EndProcedure

; ***************************************************************************************

Procedure Check_StatusBar()

  ; Liste kopieren
  ClearList(ListOld())
  ForEach ListOldStatusBar()
    AddElement(ListOld())
    ListOld() = ListOldStatusBar()
  Next
  ClearList(ListFind())
  ForEach ListFindStatusBar()
    AddElement(ListFind())
    ListFind() = ListFindStatusBar()
  Next
  
  ProcedureReturn Check_Sub(4)
  
EndProcedure

; ***************************************************************************************

Procedure Check_ToolBar()

  ; Liste kopieren
  ClearList(ListOld())
  ForEach ListOldToolBar()
    AddElement(ListOld())
    ListOld() = ListOldToolBar()
  Next
  ClearList(ListFind())
  ForEach ListFindToolBar()
    AddElement(ListFind())
    ListFind() = ListFindToolBar()
  Next
  
  ProcedureReturn Check_Sub(5)
  
EndProcedure

; ***************************************************************************************

Procedure Check_Gadget()

  ; Liste kopieren
  ClearList(ListOld())
  ForEach ListOldGadget()
    AddElement(ListOld())
    ListOld() = ListOldGadget()
  Next
  ClearList(ListFind())
  ForEach ListFindGadget()
    AddElement(ListFind())
    ListFind() = ListFindGadget()\Const
  Next
  
  ProcedureReturn Check_Sub(6)
  
EndProcedure

; ***************************************************************************************

Procedure Update_Window_Prefix()

  Protected alt.s , neu.s, sTemp.s
  
  ForEach ListCheck()
    If ListCheck()\type > 1
      Continue
    EndIf
    ; Datei EventMenu Prefix
    alt = "EventMenu_" + ListCheck()\alt + "_"
    neu = "EventMenu_" + ListCheck()\neu + "_"
    ForEach ListFileEventMenu()
      sTemp = ReplaceString(ListFileEventMenu(), alt, neu, #PB_String_NoCase)
      ListFileEventMenu() = sTemp
    Next
    ; Datei EventGadget Prefix
    alt = "EventGadget_" + ListCheck()\alt + "_"
    neu = "EventGadget_" + ListCheck()\neu + "_"
    ForEach ListFileEventGadget()
      sTemp = ReplaceString(ListFileEventGadget(), alt, neu, #PB_String_NoCase)
      ListFileEventGadget() = sTemp
    Next
    ; Datei EventWindow Prefix
    alt = "EventSize_" + ListCheck()\alt + "_"
    neu = "EventSize_" + ListCheck()\neu + "_"
    ForEach ListFileEventWindow()
      sTemp = ReplaceString(ListFileEventWindow(), alt, neu, #PB_String_NoCase)
      ListFileEventWindow() = sTemp
    Next
    ; Datei EventWindow Prefix
    alt = "EventExit_" + ListCheck()\alt + "_"
    neu = "EventExit_" + ListCheck()\neu + "_"
    ForEach ListFileEventWindow()
      sTemp = ReplaceString(ListFileEventWindow(), alt, neu, #PB_String_NoCase)
      ListFileEventWindow() = sTemp
    Next
    ; Window Konstanten Prefix
    alt = "#" + ListCheck()\alt + "_"
    neu = "#" + ListCheck()\neu + "_"
    ; in Datei Main
    ForEach ListFileMain()
      If FindStringEx(ListFileMain(), alt, 1)
        sTemp = ReplaceString(ListFileMain(), alt, neu, #PB_String_NoCase)
        ListFileMain() = sTemp
      EndIf
    Next
    ; in Datei EventMenu
    ForEach ListFileEventMenu()
      If FindStringEx(ListFileEventMenu(), alt, 1)
        sTemp = ReplaceString(ListFileEventMenu(), alt, neu, #PB_String_NoCase)
        ListFileEventMenu() = sTemp
      EndIf
    Next
    ; in Datei EventGadget
    ForEach ListFileEventGadget()
      If FindStringEx(ListFileEventGadget(), alt, 1)
        sTemp = ReplaceString(ListFileEventGadget(), alt, neu, #PB_String_NoCase)
        ListFileEventGadget() = sTemp
      EndIf
    Next
    ; in Datei EventWindow
    ForEach ListFileEventWindow()
      If FindStringEx(ListFileEventWindow(), alt, 1)
        sTemp = ReplaceString(ListFileEventWindow(), alt, neu, #PB_String_NoCase)
        ListFileEventWindow() = sTemp
      EndIf
    Next
    
  Next

EndProcedure

; ***************************************************************************************

Procedure Update_Procedure()

  Protected alt.s , neu.s, sTemp.s
  
  ForEach ListCheck()
    ; Datei EventMenu
    If ListCheck()\type = 3
      alt = "EventMenu_" + ListCheck()\alt
      neu = "EventMenu_" + ListCheck()\neu
      ForEach ListFileEventMenu()
        sTemp = ReplaceStringEx(ListFileEventMenu(), alt, neu)
        ListFileEventMenu() = sTemp
      Next
    EndIf
    ; Datei EventGadget
    If ListCheck()\type = 6
      alt = "EventGadget_" + ListCheck()\alt
      neu = "EventGadget_" + ListCheck()\neu
      ForEach ListFileEventGadget()
        sTemp = ReplaceStringEx(ListFileEventGadget(), alt, neu)
        ListFileEventGadget() = sTemp
      Next
    EndIf
    ; Datei EventWindow
    If ListCheck()\type = 1
      alt = "EventSize_" + ListCheck()\alt
      neu = "EventSize_" + ListCheck()\neu
      ForEach ListFileEventWindow()
        sTemp = ReplaceStringEx(ListFileEventWindow(), alt, neu)
        ListFileEventWindow() = sTemp
      Next
      alt = "EventExit_" + ListCheck()\alt
      neu = "EventExit_" + ListCheck()\neu
      ForEach ListFileEventWindow()
        sTemp = ReplaceStringEx(ListFileEventWindow(), alt, neu)
        ListFileEventWindow() = sTemp
      Next
    EndIf
    
  Next

EndProcedure

; ***************************************************************************************

Procedure Update_Konstanten()

  Protected alt.s , neu.s, sTemp.s
  
  ForEach ListCheck()
    ; Datei EventMenu
    alt = "#" + ListCheck()\alt
    neu = "#" + ListCheck()\neu
    ; Datei Main
    ForEach ListFileMain()
      sTemp = ReplaceStringEx(ListFileMain(), alt, neu)
      ListFileMain() = sTemp
    Next
    ; Datei EventMenu
    ForEach ListFileEventMenu()
      sTemp = ReplaceStringEx(ListFileEventMenu(), alt, neu)
      ListFileEventMenu() = sTemp
    Next
    ; Datei EventGadget
    ForEach ListFileEventGadget()
      sTemp = ReplaceStringEx(ListFileEventGadget(), alt, neu)
      ListFileEventGadget() = sTemp
    Next
    ; Datei EventWindow
    ForEach ListFileEventWindow()
      sTemp = ReplaceStringEx(ListFileEventWindow(), alt, neu)
      ListFileEventWindow() = sTemp
    Next
    ; Datei EventWindow
    ForEach ListFileEventWindow()
      sTemp = ReplaceStringEx(ListFileEventWindow(), alt, neu)
      ListFileEventWindow() = sTemp
    Next
    
  Next

EndProcedure

; ***************************************************************************************

Procedure Update_Open_Window()

  Protected alt_open.s , neu_open.s, alt_resize.s, neu_resize.s, sTemp.s
  
  ForEach ListCheck()
    If ListCheck()\type > 1
      Continue
    EndIf
    alt_open = "Open_" + ListCheck()\alt + "()"
    neu_open = "Open_" + ListCheck()\neu + "()"
    alt_resize = "Resize_" + ListCheck()\alt
    neu_resize = "Resize_" + ListCheck()\neu
    
    ; Datei Main
    ForEach ListFileMain()
      sTemp = ReplaceStringEx(ListFileMain(), alt_open, neu_open)
      ListFileMain() = sTemp
    Next
    ; Datei EventMenu
    ForEach ListFileEventMenu()
      sTemp = ReplaceStringEx(ListFileEventMenu(), alt_open, neu_open)
      ListFileEventMenu() = sTemp
    Next
    ; Datei EventGadget
    ForEach ListFileEventGadget()
      sTemp = ReplaceStringEx(ListFileEventGadget(), alt_open, neu_open)
      ListFileEventGadget() = sTemp
    Next
    ; Datei EventWindow
    ForEach ListFileEventWindow()
      sTemp = ReplaceStringEx(ListFileEventWindow(), alt_open, neu_open)
      ListFileEventWindow() = sTemp
      sTemp = ReplaceStringEx(ListFileEventWindow(), alt_resize, neu_resize)
      ListFileEventWindow() = sTemp
    Next
    
  Next

EndProcedure

; ***************************************************************************************

Procedure Update_IncludeFiles()

Protected alt.s , neu.s, sTemp.s, ft, count, file.s
  
  ForEach ListIncludeFiles()
    ClearList(ListFileInclude())
    file = ListIncludeFiles()
    ; Datei laden
    If OpenFile(0, ListIncludeFiles())
      If ReadStringFormat(0) <> #PB_Ascii
       Ft = #PB_UTF8
      Else 
       Ft = #PB_Ascii
      EndIf
      While Eof(0) = 0
        AddElement(ListFileInclude())
        ListFileInclude() = ReadString(0, ft)
      Wend
      CloseFile(0)
    Else
      Info(" -> Error OpenFile " + ListIncludeFiles() + " / " + FormatMessage(GetLastError_()))
      Continue
    EndIf
    
    ; Zhler nderungen
    count = 0
    ; Window Konstanten Prefix
    ForEach ListCheck()
      If ListCheck()\type > 1
        Continue
      EndIf
      alt = "#" + ListCheck()\alt + "_"
      neu = "#" + ListCheck()\neu + "_"
      ForEach ListFileInclude()
        If FindStringEx(ListFileInclude(), alt, 1)
          sTemp = ReplaceString(ListFileInclude(), alt, neu, #PB_String_NoCase)
          If sTemp <> ListFileInclude()
            ListFileInclude() = sTemp
            count + 1
          EndIf
        EndIf
      Next
    Next
    ; Konstanten
    ForEach ListCheck()
      alt = "#" + ListCheck()\alt
      neu = "#" + ListCheck()\neu
      ForEach ListFileInclude()
        sTemp = ReplaceStringEx(ListFileInclude(), alt, neu)
        If sTemp <> ListFileInclude()
          ListFileInclude() = sTemp
          count + 1
        EndIf
      Next
    Next
    ; Open_Window
    ForEach ListCheck()
      If ListCheck()\type > 1
        Continue
      EndIf
      alt = "Open_" + ListCheck()\alt + "()"
      neu = "Open_" + ListCheck()\neu + "()"
      ForEach ListFileInclude()
        sTemp = ReplaceStringEx(ListFileInclude(), alt, neu)
        If sTemp <> ListFileInclude()
          ListFileInclude() = sTemp
          count + 1
        EndIf
      Next
    Next
    ; Datei Schreiben
    If count
      Info(" -> Update Includefile " + ListIncludeFiles() + " / Count Change: " + Str(count))
      If CreateFile(0, ListIncludeFiles())
        ForEach ListFileInclude()
          WriteStringN(0, ListFileInclude(), ft)
        Next
        CloseFile(0)
      Else
        Info(" -> Error WriteFile " + ListIncludeFiles() + " / " + FormatMessage(GetLastError_()))
      EndIf
    EndIf
  Next

EndProcedure

; ***************************************************************************************

; ***************************************************************************************

; ***************************************************************************************

; ***************************************************************************************

Procedure DoStart1()
  
  Protected ft
  
  If IsLoad = 0
    If Project_Save_As() = 0
      ProcedureReturn 0
    EndIf
  EndIf
  
  Info("Generate Code Step 1 ...")
  
  Info("- Check Main.pb")
  ft = DoCheckBOM()
  Select ft
    Case #Null      : Info(" -> Main.pb not found.")
    Case #PB_Ascii  : Info(" -> No BOM found.")
    Case #PB_UTF8   : Info(" -> UTF-8 BOM found.")
    Case #PB_Unicode: Info(" -> UTF-16 (Little Endian) BOM found.")

    Case #PB_UTF16BE: Info(" -> UTF-16 (Big Endian) BOM found.")
    Case #PB_UTF32  : Info(" -> UTF-32 (Little Endian) BOM found.")
    Case #PB_UTF32BE: Info(" -> UTF-32 (Big Endian) BOM found.")
  EndSelect
  ;If ft <> #PB_UTF8
    If Switch\Utf8
      FormatFile = #PB_UTF8
    Else
      FormatFile = #PB_Ascii
    EndIf
  ;EndIf
  
  Info("- Load Files...")
  ; Listen lschen
  DoInitList()
  ; Dateiliste laden
  DoLoadFileList()
  ; Dateien einlesen
  DoLoadCommon()
  ; Dateien Laden
  DoLoadFiles()
  If ListSize(ListFiles()) = 0
    Info("None Files to Generate.")
    DisableWindow(#Main, #False)
    ProcedureReturn 0
  EndIf
  ; Liste Includefiles
  DoLoadIncludeFileList("Main.pb")
  Info("- Interpret code...")
  ; Prefix setzen
  If DoSetPrefix() = #False
    DisableWindow(#Main, #False)
    ProcedureReturn 0
  EndIf
  ; Konstanten suchen
  If DoFindConstanten() = #False
    DisableWindow(#Main, #False)
    ProcedureReturn 0
  EndIf
  ; Parend Window setzen
  If Switch\Parend
    DoSetParendWindow()
  EndIf
  ; PB_Ignore setzen
  If Switch\PB_Ignore
    DoSetPB_Ignore()
  EndIf
  ; Setze MenuItemTabs
  DoCreateMenuItemTabs()
  ; Multilang
  If Switch\Multilang
    DoSetLanguage()
    DoFindLanguage()
    DoCreateLanguage()
  EndIf
  ; Font Include
  DoCreateFont()
  ; Image Include
  DoFindLoadImage()
  DoCreateImage()
  ; Image Include
  If Switch\Image_Null
    DoFindImageNull()
  EndIf
  ; Enummeration erzeugen
  DoCreateEnumeration()
  
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure DoStart2()

  Info("Generate Code Step 2 ...")
  Info("- Check Constants...")
  
  ; Neu Check
  If Check_Window() = #False
    ProcedureReturn 0
  EndIf
  
  If Check_Menu() = #False
    ProcedureReturn 0
  EndIf
  
  If Check_MenuItem() = #False
    ProcedureReturn 0
  EndIf
  
  If Check_StatusBar() = #False
    ProcedureReturn 0
  EndIf
  
  If Check_ToolBar() = #False
    ProcedureReturn 0
  EndIf
  
  If Check_Gadget() = #False
    ProcedureReturn 0
  EndIf
  
  ProcedureReturn #True
  
EndProcedure

; ***************************************************************************************

Procedure DoStart3()

  Info("Generate Code Step 3 ...")
  ; Backup
  Info("- Make Backup...")
  DoMakeBackup()
  
  Info("- Update Prefix")
  Update_Window_Prefix()
  Info("- Update Procedure")
  Update_Procedure()
  Info("- Update Constants")
  Update_Konstanten()
  Info("- Update Open Window")
  Update_Open_Window()
  Info("- Update IncludeFiles")
  Update_IncludeFiles()
  
EndProcedure

; ***************************************************************************************

Procedure DoStart4()
  
  Info("Generate Code Step 4 ...")
  ; Main Erzeugen (Update)
  Info("- Create new code...")
  DoCreateMain()
  ; Common erzeugen
  DoCreateCommon()
  ; EventMain erzeugen
  DoCreateEventMain()
  ; MacMenu erzeugen
  If Switch\MacMenuEvents
    DoCreateMacEventMenu()
  EndIf
  ; EventMenu erzeugen
  DoCreateEventMenu()
  ; EventSize erzeugen
  DoCreateEventSize()
  ; EventExit erzeugen
  DoCreateEventExit()
  ; EventGadget erzeugen
  DoCreateEventGadget()
  ; Info
  Info(" -> Count Window: " + Str(ListSize(ListFindWindow())))
  Info(" -> Count MenuBar: " + Str(ListSize(ListFindMenu())))
  Info(" -> Count MenuItem: " + Str(ListSize(ListFindMenuItem())))
  Info(" -> Count StatusBar: " + Str(ListSize(ListFindStatusBar())))
  Info(" -> Count ToolBar: " + Str(ListSize(ListFindToolBar())))
  Info(" -> Count Gadget: " + Str(ListSize(ListFindGadget())))
  Info(" -> Count Image: " + Str(ListSize(ListFindImage())))
  ; Dateien Schreiben
  Info("- Write Files...")
  DoWriteFiles()
  SaveProject(path_project, #True)
  ; Update OldList
  ClearList(ListOldWindow())
  CopyList(ListFindWindow(), ListOldWindow())
  
  ClearList(ListOldMenu())
  CopyList(ListFindMenu(), ListOldMenu())
  
  ClearList(ListOldMenuItem())
  CopyList(ListFindMenuItem(), ListOldMenuItem())
  
  ClearList(ListOldStatusBar())
  CopyList(ListFindStatusBar(), ListOldStatusBar())
  
  ClearList(ListOldToolBar())
  CopyList(ListFindToolBar(), ListOldToolBar())
  
  ClearList(ListOldGadget())
  ForEach ListFindGadget()
    AddElement(ListOldGadget())
    ListOldGadget() = ListFindGadget()\Const
  Next
  
  ; Fertig
  Info("Ready.")
  Info("")
  ; Freigabe Hauptfenster
  DisableWindow(#Main, #False)
  
EndProcedure

; ***************************************************************************************

Procedure DoStart(ID)

  ; Startfenster schliessen
  SendEvent(#PB_Event_Gadget, #Main, #Main_Command, #EvCloseStart, 0)  
  
  If DoStart1() = 0
    Info("Cancel.")
    Info("")
    DisableWindow(#Main, #False)
    ProcedureReturn 0
  EndIf

  If DoStart2() = 0
    Info("Cancel.")
    Info("")
    DisableWindow(#Main, #False)
    ProcedureReturn 0
  EndIf

  DoStart3()
  
  If DoStart4() = 0
    ProcedureReturn 0
  EndIf

EndProcedure

; ***************************************************************************************
; IDE Options = PureBasic 5.62 (MacOS X - x64)
; CursorPosition = 441
; FirstLine = 411
; Folding = ---------
; HideErrorLog
; CompileSourceDirectory