﻿;- Event Designer Main Program for Purebasic v4.x

; ***************************************************************************************

;- Global Variable
Global ExitApplication = #False

#PROGRAM = "EventDesigner v1.08"
#REVISION = "Rev. "
#COPYRIGHT = "©2017-2018 by Michael Kastner (mk-soft)"

Global ABOUT.s
ABOUT = #PROGRAM + #LF$ + #REVISION + Str(#PB_Compiler_Date / 3600) + #LF$ + #LF$ + #COPYRIGHT

; ***************************************************************************************

EnableExplicit

IncludeFile "Images.pb"
;- Include CommonFile
IncludeFile "CommonFile.pb"

;- Include UserFiles
;IncludeFile "???.pb"
IncludeFile "SendEvent.pb"
IncludeFile "Modul_Directory.pb"
IncludeFile "INI-File.pb"
IncludeFile "Global.pb"
IncludeFile "GlobalFunction.pb"
IncludeFile "Function.pb"
IncludeFile "Lizenztext.pb"

;- Include EventFiles
IncludeFile "EventMenu.pb"
IncludeFile "EventGadget.pb"
IncludeFile "EventWindow.pb"
IncludeFile "EventMain.pb"

; ***************************************************************************************

;- Main Program

Open_Main()

  If WindowID(#Main)
    
    CompilerIf #PB_Compiler_OS = #PB_OS_MacOS
      MenuItem(#PB_Menu_About, "")
      MenuItem(#PB_Menu_Preferences, "")
      MenuItem(#PB_Menu_Quit, "")
    CompilerEndIf
   
  CompilerIf #PB_Compiler_OS = #PB_OS_MacOS
    MenuItem(#PB_Menu_About, "")
    MenuItem(#PB_Menu_Preferences, "")
  CompilerEndIf
  
  Add_ToolBar()
  AddStatusBarField(#PB_Ignore)
  
  ; Fensteranpassung
  hSplitter = SplitterGadget(#PB_Any, 0, 0 , 800, 600, #Main_Listview_Common, #Main_Listview_Status, #PB_Splitter_Separator)
  AddKeyboardShortcut(#Main, #PB_Shortcut_Control |#PB_Shortcut_N, #Main_Projekt_neu)
  AddKeyboardShortcut(#Main, #PB_Shortcut_Control |#PB_Shortcut_L, #Main_Projekt_laden)
  AddKeyboardShortcut(#Main, #PB_Shortcut_Control |#PB_Shortcut_S, #Main_Projekt_speichern)
  
  InitProgram()
  
  UpdateWindow()
  SetGadgetState(hSplitter, 100)
  
  EnableGadgetDrop(#Main_Listview_Common, #PB_Drop_Files, #PB_Drag_Copy)
  
  Repeat
  
    Select WaitWindowEvent()
    
      Case #PB_Event_Menu
        CompilerIf #PB_Compiler_OS = #PB_OS_MacOS
          Select EventMenu()
            Case #PB_Menu_About : PostEvent(#PB_Event_Menu, #Main, #Main_Info)
            Case #PB_Menu_Preferences : PostEvent(#PB_Event_Menu, #Main, #Main_Menu_UserGadget)
            Case #PB_Menu_Quit : PostEvent(#PB_Event_Menu, #Main, #Main_Beenden)
          EndSelect
        CompilerEndIf
        MyEventMenu(EventMenu())
      Case #PB_Event_Gadget
        MyEventGadget(EventGadget(), EventType())
      Case #PB_Event_SizeWindow
        MyEventSize(EventWindow())
      Case #PB_Event_CloseWindow
        MyEventExit(EventWindow())
      Case #PB_Event_GadgetDrop
        Select EventGadget()
          Case #Main_Listview_Common
            DropCommonFiles()
        EndSelect
      Case #PB_Event_Repaint
        ;
      Case #PB_Event_MoveWindow
        ;
      Case #PB_Event_ActivateWindow
        ;
      Case #PB_Event_SysTray
        ;
        
    EndSelect
    
  Until ExitApplication = #True
  
  ExitProgram()
  
EndIf

End

; ***************************************************************************************

DataSection
  Main:
    IncludeBinary "subMain.unicode"
    Data.w 0
  EventMainData:
    IncludeBinary "subEventMainData.unicode"
    Data.w 0
  EventMainDataMac:
    IncludeBinary "subEventMainDataMac.unicode"
    Data.w 0
  Language:
    IncludeBinary "subLanguage.unicode"
    Data.w 0
EndDataSection

; ***************************************************************************************
; IDE Options = PureBasic 5.46 LTS (MacOS X - x64)
; CursorPosition = 15
; FirstLine = 2
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; Executable = Setup/Mac/EventDesigner64.app
; CompileSourceDirectory